<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Rating plugin 2.0 for Geeklog                                             |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | functions.inc                                                             |
// |                                                                           |
// | config file for the Rating plugin for Geeklog.                         |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright  (C) 2006 Euan McKay  - info AT heatherengineering DOT com      |
// | Copyright  (C) 2006 Tom Homer	 - TomHomer AT cogeco DOT net              |
// | For support and information, visit http://www.heatherengineering.com/     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


require_once ('../../../lib-common.php');
require_once ('../../auth.inc.php');



$display = '';

if (!SEC_hasRights ('rating.edit')) {
    $display .= COM_siteHeader ('menu');
    $display .= COM_startBlock ($MESSAGE[30], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $MESSAGE[34];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("User {$_USER['username']} tried to illegally access the Rating Administration screen.");
    echo $display;
    exit;
}



function rating_config_display() 
{
	global $_CONF, $LANG_RATING, $LANG_ADMIN;
	
    $admin_interface = new Template ($_CONF['path'] . 'plugins/rating/templates/admin/');
	$admin_interface->set_file (array ('docs_interface' => 'doc_interface.thtml'));


    $text_arr = array('has_menu' =>  true,
                    'title' => $LANG_RATING[304], 
                    'instructions' => '',
                    'icon' => plugin_geticon_rating ());

    $menu_arr = array (
                    array('url' => $_CONF['site_url'] . '/admin/plugins/rating/index.php',
                        'text' => $LANG_RATING[333]),
                    array('url' => $_CONF['site_url'] . '/admin/plugins/rating/docs.php',
                          'text' => $LANG_RATING[332]),
                    array('url' => $_CONF['site_url'] . '/admin/plugins/rating/index.php?mode=edit',
                          'text' => $LANG_ADMIN['create_new']));

 	
 	$display = rating_admin_menu($text_arr, $menu_arr);

	$admin_interface->set_var ('menu', $display);
	$admin_interface->set_var('site_admin_url', $_CONF['site_admin_url']);	

	$template = new Template($_CONF['path'] . 'plugins/rating/templates/admin/');
	$template->set_file( array( 'documents' => 'docs.thtml' ));
	$admin_interface->set_var('docs',($template->parse( 'output', 'documents' ))); 
	
    $admin_interface->parse ('output', 'docs_interface');
    $retval .= COM_startBlock();
    $retval .= $admin_interface->finish ($admin_interface->get_var ('output'));		
    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
	
	return $retval;
}	




// MAIN

global $LANG_RATING;

$mode = '';

$display .= COM_siteHeader ('menu', $LANG_RATING[309]);
$display .= rating_config_display();
$display .= COM_siteFooter ();

// display page ****************************************************************

echo $display;

?>