<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Rating pluginfor Geeklog                                                  |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | index.inc                                                                 |
// |                                                                           |
// | index file for the Rating plugin for Geeklog.                             |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright  (C) 2006 Euan McKay  - info AT heatherengineering DOT com      |
// | Copyright  (C) 2006 Tom Homer	 - TomHomer AT cogeco DOT com              |
// | For support and information, visit http://www.heatherengineering.com/     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


/*
Admin has the following options:

view all rating items by rating
view all rating items by object
view all rating items by date
view all ratings by object type
view all ratings by date
click on rating item in any of the above, to view that single user rating item in full detail
click on rating in any of the above, to view all rating items by all users for that object
ability to edit/delete any rating/rating item
ability to delete all rating items and rating for any individual object
ability to delete all rating items/ratings for a particular type of object (story, staticpage, etc.)

This means we need the following database views:

rating items (sortable by date, rating, user, object type)
ratings (sortable by date, object type)

Admin should then be able to see a list of all rating items added recently for a quick check of inappropriate ratings.
Admin can add a comment to each rating (stored in the text column of the rating_totals table).


*/
require_once ('../../../lib-common.php');
require_once ('../../auth.inc.php');

// Uncomment the lines below if you need to debug the HTTP variables being passed
// to the script.  This will sometimes cause errors but it will allow you to see
// the data being passed in a POST operation
// echo COM_debug($_POST);
// exit;


function edit_rating ($mode, $rid = '') 
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $_RATING_CONF,
           $LANG_RATING, $LANG_ACCESS;

    $retval = '';

    $rt_templates = new Template($_CONF['path'] . 'plugins/rating/templates/admin/');
    $rt_templates->set_file('editor','ratingeditor.thtml');
    $rt_templates->set_var('site_url', $_CONF['site_url']);
    $rt_templates->set_var('site_admin_url', $_CONF['site_admin_url']);
    $rt_templates->set_var('layout_url',$_CONF['layout_url']);
    if ($mode <> 'editsubmission' AND !empty($rid)) {
        $result = DB_query("SELECT * FROM {$_TABLES['rating']} WHERE rid ='$rid'");
        $A = DB_fetchArray($result);
        $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
        if ($access == 0 OR $access == 2) {
            $retval .= COM_startBlock($LANG_RATING[310], '',
                               COM_getBlockTemplate ('_msg_block', 'header'));
            $retval .= $LANG_RATING[311];
            $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally submit or edit a rating/review $rid.");
            return $retval;
        }
    } else {
        if ($mode == 'editsubmission') {
            $result = DB_query ("SELECT * FROM {$_TABLES['ratingsubmission']} WHERE rid = '$rid'");
            $A = DB_fetchArray($result);
        } else {
            $A['rid'] = COM_makesid();
            $A['rt_id'] = '';
            $A['score'] = '1';
            $A['nickname'] = '';
            $A['location'] = '';
            $A['title'] = '';
            $A['pros'] = '';
            $A['cons'] = '';
            $A['bottomline'] = '';
            $A['comment'] = '';
            $A['owner_id'] = $_USER['uid'];
            $A['ipaddress'] = $_SERVER['REMOTE_ADDR'];
        }
        

        if (isset ($_GROUPS['Rating Admin'])) {
            $A['group_id'] = $_GROUPS['Rating Admin'];
        } else {
            $A['group_id'] = SEC_getFeatureGroup ('rating.edit');
        }
        SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_ratings']);
        $access = 3;
    }
    $retval .= COM_startBlock ($LANG_RATING[321], '',
                               COM_getBlockTemplate ('_admin_block', 'header'));

    $rt_templates->set_var('rating_id', $A['rid']);
    if (!empty($rid) && SEC_hasRights('rating.edit')) {
        $rt_templates->set_var ('delete_option', '<input type="submit" value="' . $LANG_RATING[315] . '" name="mode">');
				
				$onclick = 'onclick="return confirm(' . "'" . $LANG_RATING['delete_confirm'] . "'" . ');"'; // Delete Confirm
				$rt_templates->set_var ('delete_option', '<input type="submit" value="' . $LANG_RATING[315] . '" name="mode" ' . $onclick . '>'); // Delete Confirm
    }
    $rt_templates->set_var('lang_title', $LANG_RATING[106]);
    $rt_templates->set_var('title', htmlspecialchars (stripslashes ($A['title'])));
    $rt_templates->set_var('lang_rid', $LANG_RATING[112]);
    $rt_templates->set_var('rid', $A['rid']);

    $rt_templates->set_var('lang_rt_id', $LANG_RATING[322]);
    $rt_templates->set_var('rt_id', $A['rt_id']);
		    
    $rt_templates->set_var('lang_score', $LANG_RATING[300]);
    //$rt_templates->set_var('score', $A['score']);
    $result = DB_query( "SELECT score_min,score_max FROM {$_TABLES['rating_totals']} WHERE rt_id = '" . $A['rt_id'] . "'" );
    $N = DB_fetchArray( $result );
    $min = $N['score_min'];
    $max = $N['score_max'];
    $rt_templates->set_var('score', RATING_return_rate_combo($min,$max, $A['score']));    


    $rt_templates->set_var('lang_nickname', $LANG_RATING[338]);
    $rt_templates->set_var('nickname', stripslashes($A['nickname']) );    
    
    $rt_templates->set_var('lang_location', $LANG_RATING[339]);
    $rt_templates->set_var('location', stripslashes($A['location']) ); 
    
    $rt_templates->set_var('lang_pros', $LANG_RATING[335]);
    $rt_templates->set_var('pros', stripslashes($A['pros']) ); 
    
    $rt_templates->set_var('lang_cons', $LANG_RATING[336]);
    $rt_templates->set_var('cons', stripslashes($A['cons']) ); 
    
    $rt_templates->set_var('lang_bottomline', $LANG_RATING[337]);
    $rt_templates->set_var('bottomline', stripslashes($A['bottomline']) ); 

    $rt_templates->set_var('lang_created', $LANG_RATING[323]);
    $rt_templates->set_var('created', $A['created'] );

    $rt_templates->set_var('lang_comment', $LANG_RATING[120]);
    $rt_templates->set_var('comment', stripslashes($A['comment']));

    $rt_templates->set_var('lang_helpful_yes', $LANG_RATING[341]);
    $rt_templates->set_var('helpful_yes', $A['helpful_yes']);

    $rt_templates->set_var('lang_helpful_no', $LANG_RATING[342]);
    $rt_templates->set_var('helpful_no', $A['helpful_no']);
    
    $rt_templates->set_var('ipaddress', $A['ipaddress']);




    $rt_templates->set_var('lang_save', $LANG_RATING[313]);
    $rt_templates->set_var('lang_cancel', $LANG_RATING[314]);

    // user access info
    $rt_templates->set_var('lang_accessrights', $LANG_ACCESS['accessrights']);
    $rt_templates->set_var('lang_owner', $LANG_ACCESS['owner']);
    $rt_templates->set_var('owner_username', DB_getItem($_TABLES['users'],'username',"uid = {$A['owner_id']}")); 
    $rt_templates->set_var('owner_id', $A['owner_id']);
    $rt_templates->set_var('lang_group', $LANG_ACCESS['group']);

    $usergroups = SEC_getUserGroups();
    if ($access == 3) {
        $groupdd = '<select name="group_id">' . LB;
        for ($i = 0; $i < count($usergroups); $i++) {
            $groupdd .= '<option value="' . $usergroups[key($usergroups)] . '"';
            if ($A['group_id'] == $usergroups[key($usergroups)]) {
               $groupdd .= ' selected="selected"';
            }
            $groupdd.= '>' . key($usergroups) . '</option>' . LB;
            next($usergroups);
        }
        $groupdd .= '</select>' . LB;
    } else {
        // they can't set the group then
        $groupdd .= DB_getItem($_TABLES['groups'],'grp_name',"grp_id = {$A['group_id']}");
        $groupdd .= '<input type="hidden" name="group_id" value="' . $A['group_id'] . '">';
    }
    $rt_templates->set_var('group_dropdown', $groupdd);
    $rt_templates->set_var('lang_permissions', $LANG_ACCESS['permissions']);
    $rt_templates->set_var('lang_permissionskey', $LANG_ACCESS['permissionskey']);
    $rt_templates->set_var('permissions_editor', SEC_getPermissionsHTML($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']));
    $rt_templates->set_var('lang_lockmsg', $LANG_ACCESS['permmsg']);
    $rt_templates->parse('output', 'editor');
    $retval .= $rt_templates->finish($rt_templates->get_var('output'));

    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));

    return $retval;
}


function edit_rating_total ($mode, $rt_id = '') 
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $_RATING_CONF,
           $LANG_RATING, $LANG_ACCESS;

    $retval = '';

    $rt_templates = new Template($_CONF['path'] . 'plugins/rating/templates/admin/');
    $rt_templates->set_file('editor','ratingtotalseditor.thtml');
    $rt_templates->set_var('site_url', $_CONF['site_url']);
    $rt_templates->set_var('site_admin_url', $_CONF['site_admin_url']);
    $rt_templates->set_var('layout_url',$_CONF['layout_url']);
    if ($mode <> 'editsubmission' AND !empty($rt_id)) {
        $result = DB_query("SELECT * FROM {$_TABLES['rating_totals']} WHERE rt_id ='$rt_id'");
        $A = DB_fetchArray($result);
        $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
        if ($access == 0 OR $access == 2) {
            $retval .= COM_startBlock($LANG_RATING[310], '',
                               COM_getBlockTemplate ('_msg_block', 'header'));
            $retval .= $LANG_RATING[311];
            $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
            COM_accessLog("User {$_USER['username']} tried to illegally submit or edit rating totals $rt_id.");
            return $retval;
        }
    } else {
        if ($mode == 'editsubmission') {
            //$result = DB_query ("SELECT * FROM {$_TABLES['ratingsubmission']} WHERE rt_id = '$rt_id'");
            //$A = DB_fetchArray($result);
        } else {
            $A['rt_id'] = COM_makesid();
            $A['item_type'] = '';
            $A['item_id'] = '';
            $A['group'] = '';

            $A['score_min'] = $_RATING_CONF['score_min'];
            $A['score_max'] = $_RATING_CONF['score_max'];
            $A['count'] = '0';
            $A['total'] = '0';

            $A['title'] = '';
            $A['comment'] = '';
            $A['banner_link'] = '';
            $A['title_link'] = '';
        }
        $A['owner_id'] = $_USER['uid'];
        if (isset ($_GROUPS['Rating Admin'])) {
            $A['group_id'] = $_GROUPS['Rating Admin'];
        } else {
            $A['group_id'] = SEC_getFeatureGroup ('rating.edit');
        }
        SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_totals']);
        $access = 3;
    }
    $retval .= COM_startBlock ($LANG_RATING[312], '',
                               COM_getBlockTemplate ('_admin_block', 'header'));

    $rt_templates->set_var('ratingtotals_id', $A['rt_id']);
    if (!empty($rt_id) && SEC_hasRights('rating.edit')) {
        //$rt_templates->set_var ('delete_option', '<input type="submit" value="' . $LANG_RATING[315] . '" name="mode">');
				
				$onclick = 'onclick="return confirm(' . "'" . $LANG_RATING['delete_confirm'] . "'" . ');"'; // Delete Confirm
				$rt_templates->set_var ('delete_option', '<input type="submit" value="' . $LANG_RATING[315] . '" name="mode" ' . $onclick . '>'); // Delete Confirm
    }
    $rt_templates->set_var('lang_title', $LANG_RATING[106]);
    $rt_templates->set_var('title', htmlspecialchars (stripslashes ($A['title'])));
    $rt_templates->set_var('lang_rt_id', $LANG_RATING[112]);
    $rt_templates->set_var('rt_id', $A['rt_id']);
    $rt_templates->set_var('lang_item_ifo', $LANG_RATING[316]);

    $rt_templates->set_var('lang_item_type', $LANG_RATING[302]);
    $othercategory = $A['item_type'];
    $rt_templates->set_var('item_type_options', rating_get_item_type_list($othercategory));
    $rt_templates->set_var('lang_ifotherspecify', $LANG_RATING[318]);
    $rt_templates->set_var('item_type', $othercategory);
    
    $rt_templates->set_var('lang_item_id', $LANG_RATING[317]);
    $rt_templates->set_var('item_id', htmlspecialchars (stripslashes ($A['item_id'])));
    $rt_templates->set_var('lang_group', $LANG_RATING[303]);
    $rt_templates->set_var('group', htmlspecialchars (stripslashes ($A['group'])));

    $rt_templates->set_var('lang_min', $LANG_RATING[113]);
    $rt_templates->set_var('score_min', $A['score_min']);
    $rt_templates->set_var('lang_max', $LANG_RATING[114]);
    $rt_templates->set_var('score_max', $A['score_max']);
    $rt_templates->set_var('lang_created', $LANG_RATING[323]);
    $rt_templates->set_var('created', $A['created'] );

		if (rating_rt_is_digg($A['rt_id'])) {
			$is_digg = true;
			$rt_templates->set_var('lang_average', $LANG_RATING[331]);
		} else {
    	$rt_templates->set_var('lang_average', $LANG_RATING[110]);

	    $rt_templates->set_var('lang_count', $LANG_RATING[115]);
	    $rt_templates->set_var('count', $A['count']);
	    $rt_templates->set_var('lang_total', $LANG_RATING[116]);
	    $rt_templates->set_var('total', $A['total']);

    }
    if ($A['count'] > 0)
    {
    		if ($is_digg) {
    			$count = $A['count'];
    			$average = RATING_rating_as_html($count,$A['score_max'], (CONST_FLAG_RATING_AS_DIGG));    			
    		} else { 	
	        $average =  number_format( $A['total']/$A['count'], 2 );
	        $average = RATING_rating_as_html($average, $A['score_max'],$_RATING_CONF['user_review_default_display']);
	      }
    }
    else
    {
        $average = $LANG_RATING[105]; // "Not yet rated";
    }
    $rt_templates->set_var('average', $average);

    $rt_templates->set_var('lang_comment', $LANG_RATING[107]);
    $rt_templates->set_var('comment', stripslashes($A['comment']));

    $rt_templates->set_var('lang_banner_link', $LANG_RATING[343]);
    $rt_templates->set_var('banner_link', stripslashes($A['banner_link']));
    
    $rt_templates->set_var('lang_title_link', $LANG_RATING[344]);
    $rt_templates->set_var('title_link', stripslashes($A['title_link']));

    $rt_templates->set_var('lang_save', $LANG_RATING[313]);
    $rt_templates->set_var('lang_cancel', $LANG_RATING[314]);

    // user access info
    $rt_templates->set_var('lang_accessrights', $LANG_ACCESS['accessrights']);
    $rt_templates->set_var('lang_owner', $LANG_ACCESS['owner']);
    $rt_templates->set_var('owner_username', DB_getItem($_TABLES['users'],'username',"uid = {$A['owner_id']}")); 
    $rt_templates->set_var('owner_id', $A['owner_id']);
    $rt_templates->set_var('lang_group', $LANG_ACCESS['group']);

    $usergroups = SEC_getUserGroups();
    if ($access == 3) {
        $groupdd = '<select name="group_id">' . LB;
        for ($i = 0; $i < count($usergroups); $i++) {
            $groupdd .= '<option value="' . $usergroups[key($usergroups)] . '"';
            if ($A['group_id'] == $usergroups[key($usergroups)]) {
               $groupdd .= ' selected="selected"';
            }
            $groupdd.= '>' . key($usergroups) . '</option>' . LB;
            next($usergroups);
        }
        $groupdd .= '</select>' . LB;
    } else {
        // they can't set the group then
        $groupdd .= DB_getItem($_TABLES['groups'],'grp_name',"grp_id = {$A['group_id']}");
        $groupdd .= '<input type="hidden" name="group_id" value="' . $A['group_id'] . '">';
    }
    $rt_templates->set_var('group_dropdown', $groupdd);
    $rt_templates->set_var('lang_permissions', $LANG_ACCESS['permissions']);
    $rt_templates->set_var('lang_permissionskey', $LANG_ACCESS['permissionskey']);
    $rt_templates->set_var('permissions_editor', SEC_getPermissionsHTML($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']));
    $rt_templates->set_var('lang_lockmsg', $LANG_ACCESS['permmsg']);
    $rt_templates->parse('output', 'editor');
    $retval .= $rt_templates->finish($rt_templates->get_var('output'));

    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));

    return $retval;
}

function save_rating_totals ($rt_id, $old_rt_id, $title, $item_type, $item_typedd, $item_id, $group, $score_min, $score_max, $comment, $banner_link, $title_link, $owner_id, $group_id, $perm_owner, $perm_group, $perm_members, $perm_anon)
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $MESSAGE, $LANG_RATING,$_RATING_CONF;

    $retval = '';

    // Convert array values to numeric permission values
    if (is_array($perm_owner) OR is_array($perm_group) OR is_array($perm_members) OR is_array($perm_anon)) {
        list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($perm_owner,$perm_group,$perm_members,$perm_anon);
    }

    // clean 'em up 
    $comment = addslashes (COM_checkHTML (COM_checkWords ($comment)));
    $title = addslashes (COM_checkHTML (COM_checkWords ($title)));
    $banner_link = addslashes ($banner_link);
    $title_link = addslashes ($title_link);
    $item_type = addslashes ($item_type);

    if (empty ($owner_id)) {
        // this is new link from admin, set default values
        $owner_id = $_USER['uid'];
        if (isset ($_GROUPS['Rating Admin'])) {
            $group_id = $_GROUPS['Rating Admin'];
        } else {
            $group_id = SEC_getFeatureGroup ('rating.edit');
        }
        
		    $A = array ();
		    SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_totals']);        
        $perm_owner = $A['perm_owner'];
        $perm_group = $A['perm_group'];
        $perm_members = $A['perm_members'];
        $perm_anon = $A['perm_anon'];
    }

    if (empty ($rt_id)) {
        if (empty ($old_rt_id)) {
            $rt_id = COM_makeSid ();
        } else {
            $rt_id = $old_rt_id;
        }
    }

    $access = 0;
    $old_rt_id = addslashes ($old_rt_id);
    if (DB_count ($_TABLES['rating_totals'], 'rt_id', $old_rt_id) > 0) {
        $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['rating_totals']} WHERE rt_id = '{$rt_id}'");
        $A = DB_fetchArray ($result);
        $access = SEC_hasAccess ($A['owner_id'], $A['group_id'],
                $A['perm_owner'], $A['perm_group'], $A['perm_members'],
                $A['perm_anon']);
    } else {
        $access = SEC_hasAccess ($owner_id, $group_id, $perm_owner, $perm_group,
                $perm_members, $perm_anon);
    }
    // Check for blank item_type
    $item_type_flag = true;
    if (($item_typedd == $LANG_RATING[319]) AND (trim($item_type) == '' )){$item_type_flag = false;}
    
    if (($access < 3) || !SEC_inGroup ($group_id)) {
        $display .= COM_siteHeader ('menu');
        $display .= COM_startBlock ($MESSAGE[30], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $MESSAGE[31];
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        $display .= COM_siteFooter ();
        COM_accessLog("User {$_USER['username']} tried to illegally submit or edit rating total $rt_id.");
        echo $display;
        exit;
    } elseif (!empty($score_min) && !empty($score_max) && $item_type_flag) {

        if ($item_typedd != $LANG_RATING[319] && !empty($item_typedd)) {  // Other 
            $item_type = addslashes ($item_typedd);
        } else if ($item_typedd != $LANG_RATING[319]) {
            echo COM_refresh($_CONF['site_admin_url'] . '/plugins/rating/index.php');
        }
				$created = DB_getItem($_TABLES['rating_totals'],'created',"rt_id = '$old_rt_id'");
				if ($created =='') {
					$created = 'NOW()';
				} else {
					$created = "'" . $created . "'";
				}
        DB_delete ($_TABLES['rating_totals'], 'rt_id', $old_rt_id);

        DB_save ($_TABLES['rating_totals'], 'rt_id,item_type,item_id,`group`,score_min,score_max,title,`comment`,`banner_link`,`title_link`,created,owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon', "'$rt_id','$item_type','$item_id','$group',$score_min,$score_max,'$title','$comment','$banner_link','$title_link', $created,$owner_id,$group_id,$perm_owner,$perm_group,$perm_members,$perm_anon");
				
				// Update ids for rating record if rating total id has changed
				if ($old_rt_id != $rt_id) {
					$SQL = "UPDATE {$_TABLES['rating']} SET rt_id = '$rt_id' WHERE rt_id = '$old_rt_id'";
					//echo $SQL;
					$result = DB_query ($SQL);
				}

				RATING_rebuild_totals ($rt_id);
        
        //COM_rdfUpToDateCheck ('rating', $item_type, $rt_id);

        return COM_refresh ($_CONF['site_admin_url'] . '/plugins/rating/index.php?msg=5');
    } else { // missing fields
        $retval .= COM_siteHeader('menu');
        $retval .= COM_errorLog($LANG_RATING[320],2);
        
        if (DB_count ($_TABLES['rating_totals'], 'rt_id', $old_rt_id) > 0) {
            $retval .= edit_rating_total ('edit', $old_rt_id);
        } else {
            $retval .= edit_rating_total ('edit', '');
        }
        $retval .= COM_siteFooter();

        return $retval;
    }
}

function save_rating ($rid, $old_rid, $title, $rt_id, $nickname, $location, $pros, $cons, $bottomline, $score, $comment, $helpful_yes, $helpful_no, $ipaddress, $owner_id, $group_id, $perm_owner, $perm_group, $perm_members, $perm_anon)
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $MESSAGE, $LANG_RATING,$_RATING_CONF;

    $retval = '';

    // Convert array values to numeric permission values
    if (is_array($perm_owner) OR is_array($perm_group) OR is_array($perm_members) OR is_array($perm_anon)) {
        list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($perm_owner,$perm_group,$perm_members,$perm_anon);
    }

    // clean 'em up 
    $comment = addslashes (COM_checkHTML (COM_checkWords ($comment)));
    $title = addslashes (COM_checkHTML (COM_checkWords ($title)));
    $nickname = addslashes (COM_checkHTML (COM_checkWords ($nickname)));
    $location = addslashes (COM_checkHTML (COM_checkWords ($location)));
    $pros = addslashes (COM_checkHTML (COM_checkWords ($pros)));
    $cons = addslashes (COM_checkHTML (COM_checkWords ($cons)));
    $bottomline = addslashes (COM_checkHTML (COM_checkWords ($bottomline)));

    if (empty ($owner_id)) {
        // this is new link from admin, set default values
        $owner_id = $_USER['uid'];
        if (isset ($_GROUPS['Rating Admin'])) {
            $group_id = $_GROUPS['Rating Admin'];
        } else {
            $group_id = SEC_getFeatureGroup ('rating.edit');
        }
        
		    $A = array ();
		    SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_ratings']);        
        $perm_owner = $A['perm_owner'];
        $perm_group = $A['perm_group'];
        $perm_members = $A['perm_members'];
        $perm_anon = $A['perm_anon'];
    }

    if (empty ($rid)) {
        if (empty ($old_rid)) {
            $rid = COM_makeSid ();
        } else {
            $rid = $old_rid;
        }
    }

		// Check to see Rating Total ID exists
		$rt_id_flag = false;
		if (DB_count ($_TABLES['rating_totals'], 'rt_id', $rt_id) > 0) {$rt_id_flag = true;}

    $access = 0;
    $old_rid = addslashes ($old_rid);
    if (DB_count ($_TABLES['rating'], 'rid', $old_rid) > 0) {
        $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['rating']} WHERE rid = '{$rid}'");
        $A = DB_fetchArray ($result);
        $access = SEC_hasAccess ($A['owner_id'], $A['group_id'],
                $A['perm_owner'], $A['perm_group'], $A['perm_members'],
                $A['perm_anon']);
    } else {
        $access = SEC_hasAccess ($owner_id, $group_id, $perm_owner, $perm_group,
                $perm_members, $perm_anon);
    }
    
    if (($access < 3) || !SEC_inGroup ($group_id)) {
        $display .= COM_siteHeader ('menu');
        $display .= COM_startBlock ($MESSAGE[30], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $MESSAGE[31];
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        $display .= COM_siteFooter ();
        COM_accessLog("User {$_USER['username']} tried to illegally submit or edit rating/review $rid.");
        echo $display;
        exit;
    } elseif (!empty($score) && !empty($rt_id) && $rt_id_flag) {
				// Keep existing data if needed
				if (DB_count ($_TABLES['rating'], 'rid', $old_rid) > 0) {  
					$created = DB_getItem($_TABLES['rating'],'created',"rid = '$rid'");
					$owner_id = DB_getItem($_TABLES['rating'],'owner_id',"rid = '$rid'");
					$ipaddress = DB_getItem($_TABLES['rating'],'ipaddress',"rid = '$rid'");
				} else {
					if (DB_count ($_TABLES['ratingsubmission'], 'rid', $old_rid) > 0) {  
						$created = DB_getItem($_TABLES['ratingsubmission'],'created',"rid = '$rid'");
					} else {
						$created = date("F j, Y, g:i a");
					}
				}
        DB_delete ($_TABLES['ratingsubmission'], 'rid', $old_rid);
        DB_delete ($_TABLES['rating'], 'rid', $old_rid);

        DB_save ($_TABLES['rating'], 'rid,rt_id,created,score,nickname,location,title,pros,cons,bottomline,`comment`,helpful_yes,helpful_no,ipaddress,owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon'
        , "'$rid','$rt_id','$created',$score,'$nickname','$location','$title','$pros','$cons','$bottomline','$comment',$helpful_yes,$helpful_no,'$ipaddress',$owner_id,$group_id,$perm_owner,$perm_group,$perm_members,$perm_anon");
        RATING_rebuild_totals ($rt_id);
        
        //COM_rdfUpToDateCheck ('rating', $item_type, $rt_id);

        return COM_refresh ($_CONF['site_admin_url'] . '/plugins/rating/index.php?msg=6');
    } else { // missing fields
        $retval .= COM_siteHeader('menu');
        $retval .= COM_errorLog($LANG_RATING[324],2);
        
        if (DB_count ($_TABLES['rating'], 'rid', $old_rid) > 0) {
            $retval .= edit_rating ('edit', $old_rid);
        } else {
            $retval .= edit_rating ('edit', '');
        }
        $retval .= COM_siteFooter();

        return $retval;
    }
}


function delete_rating ($rid)
{
    global $_CONF, $_TABLES, $_USER;

    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon,rt_id FROM {$_TABLES['rating']} WHERE rid ='$rid'");
    $A = DB_fetchArray ($result);
		
		$rt_id = $A['rt_id'];
		
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'],
            $A['perm_group'], $A['perm_members'], $A['perm_anon']);
    if ($access < 3) {

        COM_accessLog ("User {$_USER['username']} tried to illegally delete rating $rid.");
        return COM_refresh ($_CONF['site_admin_url'] . '/plugins/rating/index.php');
    }

    DB_delete ($_TABLES['rating'], 'rid', $rid);
    DB_delete ($_TABLES['ratingsubmission'], 'rid', $rid);
		
		RATING_rebuild_totals ($rt_id);

    return COM_refresh ($_CONF['site_admin_url'] . '/plugins/rating/index.php?msg=8');
}

function delete_rating_totals ($rt_id)
{
    global $_CONF, $_TABLES, $_USER;

    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['rating_totals']} WHERE rt_id ='$rt_id'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'], $A['perm_owner'],
            $A['perm_group'], $A['perm_members'], $A['perm_anon']);
    if ($access < 3) {
        COM_accessLog ("User {$_USER['username']} tried to illegally delete rating totals $rt_id.");
        return COM_refresh ($_CONF['site_admin_url'] . '/plugins/rating/index.php');
    }

		// Delete all ratings associated with rt
		DB_delete ($_TABLES['rating'], 'rt_id', $rt_id);
		DB_delete ($_TABLES['ratingsubmission'], 'rt_id', $rt_id);
    DB_delete ($_TABLES['rating_totals'], 'rt_id', $rt_id);
		
    return COM_refresh ($_CONF['site_admin_url'] . '/plugins/rating/index.php?msg=7');
}


function list_rating_totals ()
{
    global $_CONF, $_TABLES, $LANG_ADMIN, $LANG_RATING, $LANG_ACCESS, $_IMAGE_TYPE;
    require_once( $_CONF['path_system'] . 'lib-admin.php' );
    $retval = '';

    $header_arr = array(      # dislay 'text' and use table field 'field'
                    array('text' => $LANG_ADMIN['edit'], 'field' => 'edit', 'sort' => false),
                    //array('text' => $LANG_RATING[301], 'field' => 'view_ratings', 'sort' => false),
                    array('text' => $LANG_RATING[112], 'field' => 'rt_id', 'sort' => true),
                    array('text' => $LANG_RATING[106], 'field' => 'title', 'sort' => true),
                  //  array('text' => $LANG_RATING[107], 'field' => 'info', 'sort' => true),
                    array('text' => $LANG_RATING[302], 'field' => 'item_type', 'sort' => true),
                    array('text' => $LANG_RATING[317], 'field' => 'item_id', 'sort' => true),
                  //  array('text' => $LANG_RATING[303], 'field' => 'group', 'sort' => true),
                    array('text' => $LANG_RATING[306], 'field' => 'count', 'sort' => true),
                    array('text' => $LANG_RATING[334], 'field' => 'average', 'sort' => true),
                    array('text' => $LANG_ACCESS['access'], 'field' => 'access', 'sort' => false));

    $defsort_arr = array('field' => 'title', 'direction' => 'asc');

    $text_arr = array('has_menu' =>  true,
                      'has_extras'   => true,
                      'instructions' => '',
                      'title' => $LANG_RATING[304], 
                      'instructions' => '<p>' . $LANG_RATING[305] . '</p>',
                      'form_url' => $_CONF['site_admin_url'] . "/plugins/rating/index.php",
                      'icon' => plugin_geticon_rating ());

    $menu_arr = array (
                    array('url' => $_CONF['site_url'] . '/admin/plugins/rating/index.php',
                        'text' => $LANG_RATING[333]),
                    array('url' => $_CONF['site_url'] . '/admin/plugins/rating/docs.php',
                          'text' => $LANG_RATING[332]),
                    array('url' => $_CONF['site_url'] . '/admin/plugins/rating/index.php?mode=edit',
                          'text' => $LANG_ADMIN['create_new']));

    $query_arr = array('table' => 'rating_totals',
                       'sql' => "SELECT * FROM {$_TABLES['rating_totals']} WHERE 1",
                       'query_fields' => array('title', 'item_type', 'comment', "`group`"), 
                       'default_filter' => COM_getPermSql ('AND', 0, 3));
    
    $retval .= rating_admin_menu($text_arr, $menu_arr);
    $retval .= ADMIN_list ("rating", "plugin_getListField_rating", $header_arr, $text_arr,
                            $query_arr, $defsort_arr);
    return $retval;

}





// MAIN

global $LANG_RATING;

$mode = '';
$display = '';

if (!SEC_hasRights ('rating.edit')) {
    $display .= COM_siteHeader ('menu');
    $display .= COM_startBlock ($MESSAGE[30], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $MESSAGE[34];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("User {$_USER['username']} tried to illegally access the Rating Administration screen.");
    echo $display;
    exit;
}

if (isset ($_REQUEST['mode'])) {
    $mode = $_REQUEST['mode'];
}

if (($mode == $LANG_RATING[315]) && !empty ($LANG_RATING[315])) { // delete
    $rt_id = COM_applyFilter ($_POST['rt_id']);
    $rid = COM_applyFilter ($_POST['rid']);
    if (!isset ($rt_id) || empty ($rt_id)) { 
        COM_errorLog ('Attempted to delete rating rt_id=' . $rt_id );
        $display .= COM_refresh ($_CONF['site_admin_url'] . '/plugins/rating/index.php');
    } else {
	    if (!isset ($rid) || empty ($rid)) { 
				$display .= delete_rating_totals ($rt_id); // Call delete function, for rating_totals
	    } else {
        $display .= delete_rating ($rid); // Call delete function, for review or rating
      }
    }
} else if (($mode == $LANG_RATING[313]) && !empty ($LANG_RATING[313])) { // save

		if (empty ($_POST['rid'])) {	
			// Rating Totals
		    $display = COM_siteHeader ('menu', $LANG_RATING[309]);
		    $display .= save_rating_totals (COM_applyFilter ($_POST['rt_id']),
            COM_applyFilter ($_POST['old_rt_id']),
            $_POST['title'], $_POST['item_type'],
            $_POST['item_typedd'], $_POST['item_id'], 
            $_POST['group'], COM_applyFilter ($_POST['score_min'], true),
            COM_applyFilter ($_POST['score_max'], true), $_POST['comment'], $_POST['banner_link'], $_POST['title_link'],
                        
            $_POST['owner_id'], $_POST['group_id'],
            $_POST['perm_owner'], $_POST['perm_group'],
            $_POST['perm_members'], $_POST['perm_anon']);    
	  } else {
	  	// Rating Review
            $display = COM_siteHeader ('menu', $LANG_RATING[309]);
		    $display .= save_rating (COM_applyFilter ($_POST['rid']),
            COM_applyFilter ($_POST['old_rid']),
            $_POST['title'], $_POST['rt_id'],
            $_POST['nickname'], $_POST['location'], $_POST['pros'], $_POST['cons'], $_POST['bottomline'], 
            COM_applyFilter ($_POST['score'], true), $_POST['comment'], 
            COM_applyFilter ($_POST['helpful_yes'], true), COM_applyFilter ($_POST['helpful_no'], true), $_POST['ipaddress'],
                        
            $_POST['owner_id'], $_POST['group_id'],
            $_POST['perm_owner'], $_POST['perm_group'],
            $_POST['perm_members'], $_POST['perm_anon']);    
		}
    
} else if ($mode == 'editsubmission') {
    $display .= COM_siteHeader ('menu', $LANG_RATING[309]);
    $display .= edit_rating ($mode, COM_applyFilter ($_GET['id']));
    $display .= COM_siteFooter ();
} else if ($mode == 'edit') {
		if (empty ($_GET['rid'])) {	
			// Rating Totals
            $display .= COM_siteHeader ('menu', $LANG_RATING[309]);
            if (empty ($_GET['rt_id'])) {
                $display .= edit_rating_total ($mode);
            } else {
                $display .= edit_rating_total ($mode, COM_applyFilter ($_GET['rt_id']));
            }
        } else {
            // Rating Review
            $display .= COM_siteHeader ('menu', $LANG_RATING[321]);
            if (empty ($_GET['rt_id'])) {
                $display .= edit_rating ($mode);
            } else {
                $display .= edit_rating ($mode, COM_applyFilter ($_GET['rid']));
            }		
		}
} else { // 'cancel' or no mode at all
    $display .= COM_siteHeader ('menu', $LANG_RATING[304]);
    if (isset ($_REQUEST['msg'])) {
        $msg = COM_applyFilter ($_REQUEST['msg'], true);
        if ($msg > 0) {
            $display .= COM_showMessage ($msg, 'rating');
        }
    }    
		             
$display .= COM_startBlock();
$display .= list_rating_totals();
$display .= COM_endBlock();

/*
  	// Additional Functions
		$display .= '<h2>' . $LANG_RATING[308] . '</h2>'
		             . '<p><a target="_blank" href="http://www.heatherengineering.com/plugins.php?p=rating&v='.$_RATING_CONF['version'].'">Check for updates</a></p>';
*/

}
$display .= COM_siteFooter ();

COM_output($display);


?>