<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Rating Plugin for Geeklog                                                 |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | functions.inc                                                             |
// |                                                                           |
// | functions file for the Rating plugin for Geeklog.                         |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright  (C) 2006 Euan McKay  - info AT heatherengineering DOT com      |
// | Copyright  (C) 2006 Tom Homer	 - TomHomer AT cogeco DOT com              |
// | For support and information, visit http://www.heatherengineering.com/     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//



$langfile = $_CONF['path'] . 'plugins/rating/language/'
          . $_CONF['language'] . '.php';

if (file_exists ($langfile)) {
    require_once ($langfile);
} else {
    require_once ($_CONF['path'] . 'plugins/rating/language/english.php');
}

require_once ($_CONF['path'] . 'plugins/rating/config.php');




// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+


// Menu items etc.


/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
*/
function plugin_getmenuitems_rating()
{
    global $_CONF, $LANG_RATING_STATS, $_RATING_CONF;

    if ($_RATING_CONF['hideratingmenu'] == 1) {
        $menuitems[$LANG_RATING_STATS['stats_page_title']] = $_CONF['site_url'] . '/rating/list.php';
    }
    return $menuitems;
}

function plugin_templatesetvars_rating($templatename, &$template)
{

    switch ($templatename) {

    case 'storytext':
    case 'featuredstorytext':
    case 'archivestorytext':
        $sid = $template->get_var('story_id');
        $template->set_var('rating',  RATING_display_rating($sid, 'story', $sid, 1, 5, CONST_FLAG_RATING_AS_STARS ) );
        break;
    }
}

function plugin_getuseroption_rating() 
{
	
	return false;
	
	/*
    global $_CONF, $_TABLES, $LANG_RATING;
    $link = '';
    if (SEC_hasRights('rating.view')) {
        $link = array(  $LANG_RATING[300],
                        $_CONF['site_url'] . '/rating/index.php',
                        0);
    }
    return $link;
   */
}



/**
* This will put an option for ratings in the command and control block on
* moderation.php
*
*/
function plugin_cclabel_rating()
{
    global $_CONF, $LANG_RATING;

    if (SEC_hasRights ('rating.edit')) {
        return array ($LANG_RATING[300],
                      $_CONF['site_admin_url'] . '/plugins/rating/index.php',
                      plugin_geticon_rating ());
    }

    return false;
}


/**
* returns the administrative option for this plugin
*
*/
function plugin_getadminoption_rating()
{
    global $_CONF, $LANG_RATING, $_TABLES;

    if (SEC_hasRights ('rating.edit')) {

 			$total_ratings = DB_getItem ($_TABLES['rating_totals'], 'COUNT(*)', COM_getPermSql ('',0,3));
						
      return array ($LANG_RATING[300],
                      $_CONF['site_admin_url'] . '/plugins/rating/index.php', $total_ratings);
    }
    return false;
}


/**
* 
* plugin_getheadercode_rating
* 
* returns code to include in the header section of each page
* 
*/

function plugin_getheadercode_rating()
{
    global $_CONF;
    return '<link rel="stylesheet" type="text/css" href="'.$_CONF['site_url'].'/rating/rating.css" title="rating">';
}


function plugin_whatsnewsupported_rating ()
{
    global $_TABLES, $_RATING_CONF, $LANG_RATING, $LANG_WHATSNEW;

    $hidewhatsnew = $_RATING_CONF['hidenewrating'];
    if ( $hidewhatsnew == 0 ) {
        $retval = array( $LANG_RATING[362], '<small>'
                         . COM_formatTimeString( $LANG_WHATSNEW['new_last'],
                                                 $_RATING_CONF['newratinginterval'] )
                         . '</small>'
                       );
    } else {
        $retval = false;
    }

    return $retval;
}

function plugin_getwhatsnew_rating ()
{
    global $_CONF, $_TABLES, $_USER, $_RATING_CONF, $LANG_RATING;

    $retval = '';

    // Get newest rating
    $sql = "SELECT rt_id,title FROM {$_TABLES['rating']} WHERE NOT ISNULL(comment) AND (created >= (date_sub(NOW(), INTERVAL {$_RATING_CONF['newratinginterval']} SECOND)))" . COM_getPermSQL( 'AND' ) . ' ORDER BY created DESC LIMIT 15';
    
    $result = DB_query( $sql );
    $nrows = DB_numRows( $result );

    if( $nrows > 0 )
    {
        $newlinks = array();
        for( $x = 0; $x < $nrows; $x++ )
        {
            $A = DB_fetchArray( $result );
            $A['title'] = stripslashes( $A['title'] );

            $linkUrl =  $_CONF['site_url'] . '/rating/review.php?rt_id=' . $A['rt_id'] . '&amp;mode=view';
            
            // Trim the length if over 16 characters
            $itemlen = strlen( $A['title'] );
            if( $itemlen > 16 )
            {
                $newratings [] = '<a href="' . $linkUrl . '" title="'
                    . $A['title'] . '">' . substr( $A['title'], 0, 16 )
                    . '...</a>' . LB;
            }
            else
            {
                $newratings[] = '<a href="' . $linkUrl . '">'
                    . substr( $A['title'], 0, $itemlen ) . '</a>' . LB;
            }
        }

        $retval .= COM_makeList( $newratings, 'list-new-plugins' );
    }
    else
    {
        $retval .= $LANG_RATING[66] . '<br>' . LB;
    }

    return $retval;
}

/**
* Geeklog is checking to see if this plugin supports comments, tell it no.
*/
function plugin_commentsupport_rating()
{
    return false;
}

/**
* Called by the plugin Editor to display the current plugin code version
* This may be different then the version installed and registered currently.
* If newer then you may want to run the update
*/
function plugin_chkVersion_rating()
{
    global $_RATING_CONF;

    return $_RATING_CONF['version'];
}


/**
* Returns the URL of the plugin's icon
*
* @return   string      URL of the icon
*
*/
function plugin_geticon_rating()
{
    global $_CONF;
    return $_CONF['site_url'] . '/rating/images/rating.png';
}


/**
* Implements the [rating:] autotag.
* 
* [rating:id min max function_flag]
* 
* id 							- id of rating, if does not exist then one is created using defaults
* min 						- minimum rating score allowed
* max							- maximum rating score allowed
* function_flag		- Flag.
* 									- 0 or blank - works same as current version, allows input of rating (to keep backwards compatibility)
* 									- 1 - Show rating stars
* 									- 2 - Show rating text
* 									- 4 - Show existing ratings total
* 									- 8 - Show a view button to view ratings broken out by user rating and reviews
* 									- 16 - Show an add button to input review and rating (input screen similar to add a comment)
* 
* 									This way, 24 = 8+16 = view & add buttons. Do not allow 3 (1 overrides 2?)
* 
*
*/
function plugin_autotags_rating ($op, $content = '', $autotag = '')
{
    global $_CONF, $_TABLES, $_RATING_CONF;


		$default_minmax = false;
		$error_flag = false;
		
    if ($op == 'tagname' ) {
        return 'rating';
    } else if ($op == 'parse') {
		if (!empty ($autotag['parm2'])) 
			{
				$paramaters=explode(" ", COM_applyFilter($autotag['parm2']));

				$min = $paramaters[0];
				$max = $paramaters[1];
				$function_flag = $paramaters[2];
			} else {
				$min = $_RATING_CONF['score_min'];
				$max = $_RATING_CONF['score_max'];
				$function_flag = CONST_FLAG_DEFAULT_RATING;
			} 

	    $id = COM_applyFilter ($autotag['parm1']);
			$type = 'autotagged';
			$type_id = '';
			
						
			$retval = RATING_display_rating($id, $type, $type_id, $min, $max, $function_flag);
			
			$content = str_replace ($autotag['tagstr'], $retval, $content);
				
    }
    
    return $content;
}


/**
* Display latest Diggs in the center block.
*
* @param   where   int      where the block will be displayed (0..2)
* @param   page    int      page number
* @param   topic   string   topic ID
* @return          string   HTML for the center blcok (can be empty)
*/
function plugin_centerblock_rating ($where = 1, $page = 1, $topic = '')
{
    global $_CONF, $_USER, $_TABLES, $_RATING_CONF, $LANG_RATING;

    $retval = '';

    // Retrieve Centerblock Settings
    if ($_RATING_CONF['diggs_center_block'] == 1) {
    	$cb_enable = 1;
    	$cb_homepage = $_RATING_CONF['diggs_home_page_only'];
    	$cb_where = $_RATING_CONF['diggs_center_block_where'];
    	
		  // If enabled only for homepage and this is not page 1 or a topic page,
		  // then set disable flag
		  if ($cb_homepage == 1 AND ($page > 1 OR !empty ($topic))) {
		      $cb_enable = 0;
		      
		  } elseif ($cb_homepage == 0 and $page > 1) {
		      $cb_where = 1;      // Top of Page
		  }

	    // Check if there are no featured articles in this topic
	    // and if so then place it at the top of the page
	    if (!empty ($topic)) {
	        $wheresql = "WHERE tid='$topic' AND featured > 0";
	    } else {
	        $wheresql = 'WHERE featured = 1';
	    }
	    $query = DB_query ("SELECT count(*) as count FROM {$_TABLES['stories']} $wheresql");
	    $result = DB_fetchArray ($query);
	    if ($result['count'] == 0 and $cb_where == 2) {
	        $cb_where = 1;
	    }
 
	    if ($cb_enable AND ($cb_where == $where)) {

	        $block = new Template ($_CONF['path'] . 'plugins/rating/templates/blocks');
	        $block->set_file (array ('block'=>'centerblock.thtml','record' => 'centerblock_displayline.thtml'));
	        $block->set_var ('phpself', $_CONF['site_url'] .'/index.php');
	        $block->set_var ('startblock', COM_startBlock($LANG_GF02['msg170']));
	        $block->set_var ('endblock', COM_endBlock());
	        $block->set_var ('site_url', $_CONF['site_url']);
	        $block->set_var ('layout_url', $_CONF['layout_url']);
	        
	        
	        $block->set_var ('BlOCK_TITLE', ($LANG_RATING['354'] . $_RATING_CONF['number_diggs_center_block'] . $LANG_RATING['355'] . $_RATING_CONF['new_digg_interval'] . $LANG_RATING['356']) );
	        $block->set_var ('LANG_DIGGS', $LANG_RATING['331']);
	        $block->set_var ('LANG_TOPIC', $LANG_RATING['352']);
	        $block->set_var ('LANG_LASTDIGGS', $LANG_RATING['353']);
	        

	        
	        $sql = "SELECT rt.rt_id, rt.title, rt.item_type, rt.item_id, SUM(r.score) score";
	        $sql .= " FROM {$_TABLES['rating']} r, {$_TABLES['rating_totals']} rt ";
	        $sql .= " WHERE rt.rt_id = r.rt_id";
	        $sql .= " AND (r.created >= (date_sub(NOW(), INTERVAL {$_RATING_CONF['new_digg_interval']} DAY)))";
	        $sql .= " AND rt.score_min = rt.score_max = 1" . COM_getPermSQL('AND',0,2,'rt');
	        $sql .= " GROUP BY rt.rt_id ORDER BY score DESC";
	        $result = DB_query ($sql);
	
	        if (DB_numRows($result) == 0) {
	        		$digg_title = $LANG_RATING['357'] . $_RATING_CONF['new_digg_interval'] . $LANG_RATING['356'];
	        		$block->set_var ('digg_topic', $digg_title);
	            
	            $cssid = ($cssid ==1) ? 2: 1;
	            $block->set_var ('cssid', $cssid);
	            	        		
	        		$block->parse ('block_records', 'record',true);
	        		
	        		$block->parse ('output', 'block');
	        		$retval .= $block->finish ($block->get_var ('output'));
	            return $retval;
	        }
	
	        while ($A = DB_fetchArray ($result)) {
	            $digg_title = RATING_return_parent_info ($A['rt_id'], '', false);
	            $digg_url = RATING_return_parent_info ($A['rt_id'], '', true);
	            
	            if(strlen ($digg_title) > $_RATING_CONF['digg_max_topic_size']) {
	                $digg_title = substr ($digg_title, 0, $_RATING_CONF['digg_max_topic_size']);
	                $digg_title .= '...';
	            }
	
	 						$digg_date = DB_getItem($_TABLES['rating'], 'UNIX_TIMESTAMP(created) created', "rt_id='".$A['rt_id']."' ORDER BY created DESC LIMIT 1");
							//$digg_date = COM_getUserDateTimeFormat($digg_date);
							//$digg_date = $digg_date[0];
							$digg_date = strftime($_RATING_CONF['digg_date_format'], $digg_date );

	
	            $cssid = ($cssid ==1) ? 2: 1;
	            $block->set_var ('cssid', $cssid);
	            
	            $block->set_var ('digg_number', $A['score']);
	            $block->set_var ('digg_topic', $digg_title);
	            $block->set_var ('digg_url', $digg_url);
	            $block->set_var ('digg_date', $digg_date);
	            
	            $block->parse ('block_records', 'record',true);
	        }
	
	        $block->parse ('output', 'block');
	        $retval .= $block->finish ($block->get_var ('output'));
	    }
  	}
  	
    return $retval;
}


// Stats etc


/**
* Count number of rating totals and total number of rating items
*
* @return   array(number of totals, number of items);
*
*/
function RATING_count_ratings_and_items()
{
    global $_TABLES;
    $R = DB_query("SELECT COUNT(*) AS count FROM {$_TABLES['rating_totals']}");
    $A = DB_fetchArray($R);
    $total_ratings = $A['count'];
    $R = DB_query("SELECT COUNT(*) AS count FROM {$_TABLES['rating']}");
    $A = DB_fetchArray($R);
    $total_items = $A['count'];
    if (empty ($total_items)) {
        $total_items = 0;
    }
    return array ($total_ratings, $total_items);
}


/**
* Shows the statistics for the rating plugin on stats.php.
* If $showsitestats is 1 then we are to only print the overall stats in the
* 'site statistics box' otherwise we show the detailed stats
*
* @param    int     showsitestate   Flag to let us know which stats to get
*/
function plugin_showstats_rating($showsitestats)
{
    global $_CONF, $_TABLES, $LANG_RATING_STATS;
    require_once( $_CONF['path_system'] . 'lib-admin.php' );
    $retval = '';

    $result = DB_query("SELECT rt_id,item_type,total,count,title FROM {$_TABLES['rating_totals']} WHERE (total > 0) ORDER BY total DESC LIMIT 10");
    $nrows  = DB_numRows ($result);
    if ($nrows > 0) {
        $header_arr = array(
            array('text' => $LANG_RATING_STATS['stats_page_title'], 'field' => 'sid'),
            array('text' => $LANG_RATING_STATS['stats_average'], 'field' => 'average'),
            array('text' => $LANG_RATING_STATS['stats_hits'], 'field' => 'hits'),
        );
        $data_arr = array();
        $text_arr = array('has_menu'     =>  false,
                          'title'        => $LANG_RATING_STATS['stats_headline'],
        );
        for ($i = 0; $i < $nrows; $i++) {
            $A = DB_fetchArray($result);
          	$data_arr[$i] = RATING_fetch_stats($A);
        }
        $display .= ADMIN_simpleList("", $header_arr, $text_arr, $data_arr);
    } else {
        $display .= COM_startBlock($LANG_RATING_STATS['stats_headline']);
        $display .= $LANG_RATING_STATS['stats_no_hits'];
        $display .= COM_endBlock();
    }

    return $display;
}

/**
* 
* RATING_return_totals_href
* 
* tells if an item has a total score already or not
* 
*/
function RATING_return_parent_info($rt_id, $url = '', $retlink = true)
{
	global $_TABLES, $_CONF, $_RATING_CONF;
	
	$sql = "SELECT rt_id, item_type, item_id, title FROM {$_TABLES['rating_totals']} WHERE rt_id = '" . $rt_id . "'";
  $result = DB_query ($sql);
  $arr = DB_fetchArray ($result);
  
  $retval = '';

  if ($arr['item_type'] <> '') {
    switch (strtolower($arr['item_type']))
    {
        case 'staticpage':
        		if ($retlink != true) {
            	if ($arr['title'] =='' AND $arr['item_id']!='') {
            		$retval = DB_getItem($_TABLES['staticpage'], 'sp_title', "sp_id='".$arr['item_id']."'");
            	} else {
            		$retval = $arr['title'];
            	}
            } else {
            	//$retval = "<a href=\"" .  ($_CONF['site_url'] . "/staticpages/index.php?page=".$arr['rt_id']). "\">{$arr['title']}</a>";
            	$retval = $_CONF['site_url'] . "/staticpages/index.php?page=" . $arr['item_id'];
            }
            break;
        case 'story':
        		if ($retlink != true) {
            	if ($arr['title'] =='' AND $arr['item_id']!='') {
            		$retval = DB_getItem($_TABLES['stories'], 'title', "sid='".$arr['item_id']."'");
            	} else {
            		$retval = $arr['title'];
            	}
            } else {
            	//$retval = "<a href=\"" .  ($_CONF['site_url'] . "/article.php?story=".$arr['rt_id']). "\">{$arr['title']}</a>";
            	$retval = $_CONF['site_url'] . "/article.php?story=" . $arr['item_id'];
            }
            break;
        case 'comment':
        		if ($retlink != true) {
        			if ($arr['title'] =='' AND $arr['item_id']!='') {
        				$retval = DB_getItem($_TABLES['comments'], 'title', "cid='".$arr['item_id']."'");
            	} else {
            		$retval = $arr['title'];   
            	}         
            } else {
            	$sid = DB_getItem($_TABLES['comments'], 'sid', "cid='".$arr['item_id']."'");
            	//$retval = "<a href=\"" .  ($_CONF['site_url'] . "/article.php?story=".$sid). "#comments\">{$arr['title']}</a>";
            	$retval = $_CONF['site_url'] . "/article.php?story=". $sid . "#comments";
            }
            break;
        case 'user':
        		if ($retlink != true) {
            	if ($arr['title'] =='' AND $arr['item_id']!='') {
            		$retval = DB_getItem($_TABLES['users'], 'username', "uid='".$arr['item_id']."'");
            	} else {
            		if ($arr['title'] =='') {
            			$retval = $arr['item_type'];
            		} else {
            			$retval = $arr['title'];
            		}
            	}
            } else {
            	$retval = $_CONF['site_url'] . "/users.php?mode=profile&uid=" . $arr['item_id'];
            }
            break;      
        case 'autotagged':
        		if ($retlink != true) {
	        		if ($arr['title'] =='') {
	        			$retval = $arr['item_type'];
            	} else {
            		$retval = $arr['title'];   
            	}  
            } else {
            	$retval = $url;
           	}
           	break;

        case $_RATING_CONF['rating_type_' . strtolower($arr['item_type'])]:
/* Currently removed this commented code from config
* the rating plugin's userdefined types
* 
* If you don't know anything about PHP OR SQL do not use!!!
*
* Current supported types include staticpage, comment, story & autotagged
* If you have a new type that you would like to link properly and display 
* a correct title use the following user sample below.  For a new type you
* would change in the $_RATING_CONF variable the text "user" to what ever 
* you called your type.  A sample user type is included below.

$_RATING_CONF['rating_type_user'] = 'user'; // Name of type     
$_RATING_CONF['rating_type_user_url'] = '/users.php?mode=profile&uid='; // Url to bring up item. Do not include site url. The id of the item must be last.
$_RATING_CONF['rating_type_user_title'] = "SELECT username FROM " . $_TABLES['users'] . " WHERE uid="; // SQL Statement to bring up title. The id of the item must be last.
*/
        
        		if ($retlink != true) {
            	if ($arr['title'] =='' AND $arr['item_id']!='' AND $_RATING_CONF['rating_type_' . strtolower($arr['item_type']) . '_title'] !='') {
            		$sql = $_RATING_CONF['rating_type_' . strtolower($arr['item_type']) . '_title'] . "'".$arr['item_id']."'";
							  $result = DB_query ($sql);
							  $A = DB_fetchArray ($result);            		
            		$retval = $A[0];
            	} else {
            		if ($arr['title'] =='') {
            			$retval = $arr['item_type'];
            		} else {
            			$retval = $arr['title'];
            		}
            	}
            } else {
            	$type_url = $_RATING_CONF['rating_type_' . strtolower($arr['item_type']) . '_url'] . $arr['item_id'];
            	if ($type_url != '' ) {
            		$retval = $_CONF['site_url'] . $type_url;
            	} else {
            		$retval = '';
            	}
            }
            break;
        default:
        		if ($retlink != true) {
	            $retval = $arr['item_type'];
            } else {
            	$retval = $url;
  					}
            break;
    }
  	
	} elseif ($url <> '') {
		if ($retlink != true) {
      $retval = $arr['item_type'];
    } else {
			$retval = $url;
		}
	}
	
	return $retval;
}

function RATING_fetch_stats($arr)
{
    global $_CONF, $_TABLES, $_RATING_CONF;

		
		$arr['title'] = RATING_return_parent_info($arr['rt_id'], '', false);
		$rt_link = RATING_return_parent_info($arr['rt_id'], '', true);
		if ($rt_link != '') {
			$arr['sid'] = "<a href=" .  $rt_link . ">{$arr['title']}</a>";
		} else {
			$arr['sid'] = $arr['title'];
		}
		
		/*
    switch ($arr['item_type'])
    {
        case 'staticpage':
            if ($arr['title'] =='') {$arr['title'] = DB_getItem($_TABLES['staticpage'], 'sp_title', "sp_id='".$arr['rt_id']."'");}
            $arr['sid'] = "<a href=\"" .  ($_CONF['site_url'] . "/staticpages/index.php?page=".$arr['rt_id']). "\">{$arr['title']}</a>";
            break;
        case 'story':
            if ($arr['title'] =='') {$arr['title'] = DB_getItem($_TABLES['stories'], 'title', "sid='".$arr['rt_id']."'");}
            $arr['sid'] = "<a href=\"" .  ($_CONF['site_url'] . "/article.php?story=".$arr['rt_id']). "\">{$arr['title']}</a>";
            break;
        case 'comment':
            if ($arr['title'] =='') {$arr['title'] = DB_getItem($_TABLES['comments'], 'title', "cid='".$arr['rt_id']."'");}
            $sid = DB_getItem($_TABLES['comments'], 'sid', "cid='".$arr['rt_id']."'");
            $arr['sid'] = "<a href=\"" .  ($_CONF['site_url'] . "/article.php?story=".$sid). "#comments\">{$arr['title']}</a>";
            break;
        case 'autotagged':
        		if ($arr['title'] =='') {
        			$arr['title'] = $arr['item_type'];
           	}
           	$arr['sid'] = $arr['title'];
           	break;
        default:
            $arr['title'] = $arr['item_type'];
            $arr['sid'] = $arr['title'];
            break;
    }
		*/
		
		// See if rating has reviews, if so then point to that instead of 
		$sql = "SELECT COUNT(rt_id) countrt_id FROM {$_TABLES['rating']} WHERE rt_id = '".$arr['rt_id']."' AND comment <>''";
    $result = DB_query ($sql);
    $B = DB_fetchArray ($result);
    $reviewcount = $B['countrt_id'];		
		if ($reviewcount > 0) 
		{
			$arr['sid'] = "<a href=\"" .  ($_CONF['site_url'] . "/rating/review.php?rt_id=".$arr['rt_id']."&amp;mode=view") . "\">" . $arr['title'] . "</a>";
		}
		
		if (rating_rt_is_digg($arr['rt_id'])) {
	  
	    $arr['average'] =	RATING_rating_as_html($arr['count'], DB_getItem($_TABLES['rating_totals'], 'score_max', "rt_id='" . $arr['rt_id'] . "'"), CONST_FLAG_RATING_AS_DIGG);
			
		} else {
	    $arr['average'] =	RATING_rating_as_html(($arr['total']/$arr['count']), DB_getItem($_TABLES['rating_totals'], 'score_max', "rt_id='" . $arr['rt_id'] . "'"),$_RATING_CONF['user_review_default_display']);
		}            

		$arr['hits'] = $arr['total'];
		
    return $arr;
}

/**
* New stats plugin API function for proper integration with the site stats
*
* @return   array(item text, item count);
*
*/
function plugin_statssummary_rating()
{
    global $LANG_RATING_STATS;

    list($total_ratings, $total_items) = RATING_count_ratings_and_items();

    $item_count = COM_NumberFormat ($total_ratings)
                . ' (' . COM_NumberFormat ($total_items) . ')';


    return array ($LANG_RATING_STATS['rating'], $item_count);
}



// Uninstall


/**
* Removes the datastructures for this plugin from the Geeklog database
*
* This may get called by the install routine to undo anything done to this
* point.
*
* @steps   Array    Holds all the steps that have been completed by the install
*
*/
function plugin_uninstall_rating()
{
    global $_TABLES, $_CONF;

    // Uninstalls the rating plugin

    // Remove the rating table
    COM_errorLog ('Dropping rating table', 1);
    DB_query ("DROP TABLE {$_TABLES['rating']}");
    COM_errorLog ('...success', 1);

    // Remove the rating table
    COM_errorLog ('Dropping rating submission table', 1);
    DB_query ("DROP TABLE {$_TABLES['ratingsubmission']}");
    COM_errorLog ('...success', 1);

    // Remove the rating table
    COM_errorLog ('Dropping rating totals table', 1);
    DB_query ("DROP TABLE {$_TABLES['rating_totals']}");
    COM_errorLog ('...success', 1);


    // Remove security for this plugin

    // Remove the rating admin group
    $grp_id = DB_getItem ($_TABLES['groups'], 'grp_id',
                          "grp_name = 'Rating Admin'");

    if (!empty ($grp_id)) {
        COM_errorLog ('Attempting to remove the Rating Admin group', 1);
        DB_query ("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id");
        COM_errorLog ('...success', 1);
    }

    // Remove the rating user group
    $grp_id2 = DB_getItem ($_TABLES['groups'], 'grp_id',
                          "grp_name = 'Rating User'");

    if (!empty ($grp_id2)) {
        COM_errorLog ('Attempting to remove the Rating User group', 1);
        DB_query ("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id2");
        COM_errorLog ('...success', 1);
    }

    // Remove related features
    $edit_id = DB_getItem ($_TABLES['features'], 'ft_id',
                           "ft_name = 'rating.edit'");
    $view_id = DB_getItem ($_TABLES['features'], 'ft_id',
                               "ft_name = 'rating.view'");
    $moderate_id = DB_getItem ($_TABLES['features'], 'ft_id',
                               "ft_name = 'rating.moderate'");
                               
    // Remove access to those features
    if (!empty ($edit_id)) {
        COM_errorLog ('Attempting to remove rating.edit rights from all groups' ,1);
        DB_query ("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $edit_id");
        COM_errorLog ('...success', 1);
    }

    if (!empty ($view_id)) {
        COM_errorLog ('Attempting to remove rating.view rights from all groups', 1);
        DB_query ("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $view_id");
        COM_errorLog ('...success', 1);
    }

    if (!empty ($view_id)) {
        COM_errorLog ('Attempting to remove rating.moderate rights from all groups', 1);
        DB_query ("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $moderate_id");
        COM_errorLog ('...success', 1);
    }


    // Remove Rating Admin group from all other groups
    if (!empty ($grp_id)) {
        COM_errorLog ('Attempting to Rating Admin group from all groups.', 1);
        DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id");
        COM_errorLog ('...success', 1);
    }
    if (!empty ($grp_id2)) {
        COM_errorLog ('Attempting to Rating User group from all groups.', 1);
        DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id2");
        COM_errorLog ('...success', 1);
    }

    // remove features
    if (!empty ($edit_id)) {
        COM_errorLog ('Attempting to remove the rating.edit feature', 1);
        DB_query ("DELETE FROM {$_TABLES['features']} WHERE ft_id = $edit_id");
        COM_errorLog ('...success', 1);
    }

    if (!empty ($view_id)) {
        COM_errorLog ('Attempting to remove the rating.view feature', 1);
        DB_query ("DELETE FROM {$_TABLES['features']} WHERE ft_id = $view_id");
        COM_errorLog ('...success', 1);
    }

    if (!empty ($view_id)) {
        COM_errorLog ('Attempting to remove the rating.moderate feature', 1);
        DB_query ("DELETE FROM {$_TABLES['features']} WHERE ft_id = $moderate_id");
        COM_errorLog ('...success', 1);
    }

    // Unregister the plugin with Geeklog
    // Always attempt to remove these entries or lib-common.php would still
    // try and read our functions.inc file ...
    COM_errorLog ('Attempting to unregister the plugin from Geeklog', 1);
    DB_query ("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'rating'");
    COM_errorLog ('...success',1);

    COM_errorLog ('Finished uninstalling the Rating plugin.', 1);

    return true;
}



// +---------------------------------------------------------------------------+
// | Rating plugin functions                                                   |
// +---------------------------------------------------------------------------+


/**
* 
* RATING_function_in_flag
* 
* given a value, returns true or false
* 
* takes values $function_flag   - flag passed in from tag
*              $function				- function you are looking for in function_flag
																- if -1 then find out if function_flag is a correct combination of features
* 															- if flag constant then see if that feature is requested
*/
function RATING_function_in_flag($function_flag, $function = -1)
{
	$retval = false;
	$continue = true;
	
	// double check function pass exists
  switch ($function)
  {
  	case '-1':   // find out if function_flag is a correct combination of features
  		break;

  	case CONST_FLAG_DEFAULT_RATING:  // Default Rating			
        break;

    case CONST_FLAG_RATING_AS_STARS:  // Show Rating as Stars
        break;

    case CONST_FLAG_RATING_AS_TEXT:  // Show Rating as Text
        break;

    case CONST_FLAG_SHOW_TOTALS:  // Show existing ratings total    
    	break;

	case CONST_FLAG_SHOW_LABEL: // Show average text		
        break;

    case CONST_FLAG_REVIEWS_VIEW:  // Rating & Review, Show View button (read only)			
        break;

    case CONST_FLAG_REVIEWS_ADD:  // Rating & Review, Show Add Button
        break;

    case CONST_FLAG_RATING_VIEW:  // Rating View only
        break;

    case CONST_FLAG_RATE_AS_TEXT:  // Rate interface
        break;

    case CONST_FLAG_RATE_AS_STARS:  // Rate interface
        break;

    case CONST_FLAG_RATE_AS_COMBO:  // Rate interface
        break;

    case CONST_FLAG_RATING_AS_DIGG:  // DIGG rating    
    	break;

    default:  // function not defined error
		$continue = false;
        break;
  }
	
	if ($continue)
	{
		if ($function == -1) {$retval = true;}  // this done becasue it is easier to see if rule is broken
		$temp = $function_flag;
		
		$max_value = CONST_MAX_CONSTANT_VALUE;
		$max = CONST_FLAG_MAX;
		
		for ($i = $max; $i >= 1; $i--) {
	    if (($temp-$max_value) >= 0) {
	        $temp = $temp - $max_value;
	        $function_array[$i] = true;
	        
	        if ($function == -1) {
	        	// See if pass rules of what can be enabled with what
					  switch ($max_value)
					  {
					    case CONST_FLAG_RATING_AS_STARS:  // Show Rating as Stars
					    	if ($function_array[2] == 1) { $retval = false;}
					
					      break;
					    case CONST_FLAG_RATING_AS_TEXT:  // Show Rating as Text
								if ($function_array[1] == 1) { $retval = false;}
					
					      break;
					    case CONST_FLAG_SHOW_TOTALS:  // Show existing ratings total
								
					      break;
							case CONST_FLAG_SHOW_LABEL: // Show average or Diggs: text
							
					      break;					      
					    case CONST_FLAG_REVIEWS_VIEW:  // Rating & Review, Show View button (read only)
								if (($function_array[8] == 1) OR ($function_array[9] == 1) OR ($function_array[10] == 1)) { $retval = false;}
								
					      break;
					    case CONST_FLAG_REVIEWS_ADD:  // Rating & Review, Show Add Button
								if (($function_array[8] == 1) OR ($function_array[9] == 1) OR ($function_array[10] == 1)) { $retval = false;}
					
					      break;
					    case CONST_FLAG_RATING_VIEW:  // View Rating only
								if (($function_array[8] == 1) OR ($function_array[9] == 1) OR ($function_array[10] == 1)) { $retval = false;}
								if (($function_array[5] == 1) OR ($function_array[6] == 1)) { $retval = false;}
								
					      break;
					    case CONST_FLAG_RATE_AS_TEXT:  // Rate interface
								if (($function_array[9] == 1) OR ($function_array[10] == 1)) { $retval = false;}
								if (($function_array[5] == 1) OR ($function_array[6] == 1)) { $retval = false;}
					
					      break;
					    case CONST_FLAG_RATE_AS_STARS:  // Rate interface
					    	if (($function_array[8] == 1) OR ($function_array[10] == 1)) { $retval = false;}
					    	if (($function_array[5] == 1) OR ($function_array[6] == 1)) { $retval = false;}
					
					      break;
					    case CONST_FLAG_RATE_AS_COMBO:  // Rate interface
								if (($function_array[8] == 1) OR ($function_array[9] == 1)) { $retval = false;}
								if (($function_array[5] == 1) OR ($function_array[6] == 1)) { $retval = false;}
						
					      break;
					    case CONST_FLAG_RATING_AS_DIGG:  // DIGG rating // can only view and have average (digg) label
					    	if (($function_array[1] == 1) OR ($function_array[2] == 1) OR ($function_array[3] == 1) OR ($function_array[6] == 1) OR ($function_array[7] == 1) OR ($function_array[8] == 1) OR ($function_array[9] == 1) OR ($function_array[10] == 1)) { $retval = false;}
					    	//if (($function_array[1] == 1) OR ($function_array[2] == 1) OR ($function_array[6] == 1) OR ($function_array[7] == 1) OR ($function_array[8] == 1) OR ($function_array[9] == 1) OR ($function_array[10] == 1)) { $retval = false;}
					    	
					    	break;					      
					    default:  // function not defined error
								$retval = false;
								
					      break;
					  }
					} else {
						// Check if Function exists in Function Flag
						If ($max_value == $function) {$retval = true;}
				  }
	     } else {
	        $function_array[$i] = false;
	    }
	    $max_value = $max_value /2;
		}		
	}

	return $retval;
}

/**
* 
* RATING_return_form
*       item_id
*       item_type
*       score_min
*       score_max
*       function_flag
* 
* returns HTML for a rating form if the user has not rated, returns the
*       present rating for that item if already rated
* 
*/
function RATING_return_form($item_id, $score_min, $score_max, $function_flag = 0, $display_text_details = true)
{

    global $_CONF, $_USER, $_RATING_CONF, $LANG_RATING, $_TABLES, $LANG01;
    
    $ipaddress = $_SERVER['REMOTE_ADDR'];
    $user_id = $_USER['uid'];
    $anon_user_can_rate = true;
		if (($_RATING_CONF['ratingloginrequired'] == 1) AND ($user_id =='' OR $user_id < 2)) {
			$anon_user_can_rate = false;
		}
		
    $t = new Template($_CONF['path'] . 'plugins/rating/templates');
    $t->set_file( array( 'page'=>'rate.thtml',
                         'text'=>'rate_item_text.thtml',
                         'rating'=>'rating.thtml',
                         'review_view'=>'review_link_view.thtml',
                         'review_add'=>'review_link_add.thtml',
                         'star'=>'rate_item_star.thtml' ));
                         
    $t->set_var('site_url', $_CONF['site_url']);
    $t->set_var('layout_url', $_CONF['layout_url']);

    $rated = RATING_check_user_rated($item_id, $user_id, $ipaddress);
    $owner_same_parent = RATING_owner_same_parent_item($item_id, $user_id);

	  if (($rated AND $display_text_details) OR !$anon_user_can_rate OR $owner_same_parent) {
	    // rated
	    if  (($rated AND $display_text_details) AND ($_RATING_CONF['show_user_rating_default_display'] == CONST_FLAG_SHOW_TOTALS) || RATING_function_in_flag($function_flag, CONST_FLAG_SHOW_TOTALS))
	    {
  			$t->set_var('lang_rate_item', $LANG_RATING[101]); // Your Rating: 
        $u = RATING_rating_as_html($rated,$score_max,
                               $_RATING_CONF['user_rating_default_display']);
	    } else {
    		$t->set_var('lang_rate_item', ''); // Your Rating: 
        $u = "";
	    }
			
	    $t->set_var('rate_item', $u);
	  } else {
      // not rated or just view
      If (!(RATING_function_in_flag($function_flag, CONST_FLAG_RATING_VIEW) OR RATING_function_in_flag($function_flag, CONST_FLAG_REVIEWS_VIEW) OR RATING_function_in_flag($function_flag, CONST_FLAG_REVIEWS_ADD))) // For Ratings only
			{
        if ((($_RATING_CONF['rating_interface_default_display'] == CONST_FLAG_RATE_AS_STARS) || RATING_function_in_flag($function_flag, CONST_FLAG_RATE_AS_STARS)) && !RATING_function_in_flag($function_flag, CONST_FLAG_RATE_AS_COMBO) && !RATING_function_in_flag($function_flag, CONST_FLAG_RATE_AS_TEXT)) {	
					$t->set_var('lang_rate_item', $LANG_RATING[102]);  // Rate:
					
	        for ($i = $score_min; $i <= $score_max; $i++)
	        {
						$t->set_var('val', $i);
						$t->set_var('id', $item_id);
						$t->parse('rate_item', 'star', true);
					}								
				} else if (($_RATING_CONF['rating_interface_default_display'] == CONST_FLAG_RATING_AS_DIGG) || RATING_function_in_flag($function_flag, CONST_FLAG_RATING_AS_DIGG)) {	
					$t->set_var('lang_rate_item', ''); // diggs
					$t->set_var('rate_item', RATING_return_rate_digg('score', $item_id), true);



				} else if ((($_RATING_CONF['rating_interface_default_display'] == CONST_FLAG_RATE_AS_COMBO) || RATING_function_in_flag($function_flag, CONST_FLAG_RATE_AS_COMBO)) && !RATING_function_in_flag($function_flag, CONST_FLAG_RATE_AS_STARS) && !RATING_function_in_flag($function_flag, CONST_FLAG_RATE_AS_TEXT)) {	
						$t->set_var('lang_rate_item', $LANG_RATING[102]);  // Rate:
						$t->set_var('rate_item', RATING_return_rate_combo($score_min,$score_max, $score_max, 'score', $item_id), true);
        } else {  // CONST_FLAG_RATE_AS_TEXT or default
        	$t->set_var('lang_rate_item', $LANG_RATING[102]);  // Rate:
	        for ($i = $score_min; $i <= $score_max; $i++)
	        {
	          $t->set_var('link_val', $i);
						$t->set_var('val', $i);
						$t->set_var('id', $item_id);
						if ($_RATING_CONF['middle'] == '') {
							$t->set_var('rate_item', $_RATING_CONF['before'], true);
							$t->parse('rate_item', 'text', true);
							$t->set_var('rate_item', $_RATING_CONF['after'], true);
						} else {
							if ($i == $score_min) {
								$t->set_var('rate_item', $_RATING_CONF['before'], true);
								$t->parse('rate_item', 'text', true);
							} elseif ($i == $score_max) {
								$t->set_var('rate_item', $_RATING_CONF['middle'], true);
								$t->parse('rate_item', 'text', true);
								$t->set_var('rate_item', $_RATING_CONF['after'], true);
							} else {
								$t->set_var('rate_item', $_RATING_CONF['middle'], true);
								$t->parse('rate_item', 'text', true);
							}
							
						}						
           }
        }
	  	}
		}
		if (($_RATING_CONF['show_averages_before'] && !$rated) || ($_RATING_CONF['show_averages_after'] && $rated)) 
		{
			if ($display_text_details AND (RATING_function_in_flag($function_flag, CONST_FLAG_SHOW_LABEL) || ($function_flag == CONST_FLAG_DEFAULT_RATING)))
			{
				if (($_RATING_CONF['rating_interface_default_display'] == CONST_FLAG_RATING_AS_DIGG) || RATING_function_in_flag($function_flag, CONST_FLAG_RATING_AS_DIGG)) {	
					$average_text = $LANG_RATING[329];  // diggs
				}else {
					$average_text = $LANG_RATING[100];
				}
			} else {
				$average_text = '';
			}
			$t->set_var('lang_item_rating', $average_text); // Average:
			
	    $A = RATING_get_total_count($item_id);
	    if (($_RATING_CONF['rating_interface_default_display'] == CONST_FLAG_RATING_AS_DIGG) || RATING_function_in_flag($function_flag, CONST_FLAG_RATING_AS_DIGG)) {	
        $average =  number_format( $A['total'], 2 );
        $v = RATING_rating_as_html($average,$score_max, $function_flag);

	  	} else {
		    if ($A['count'] > 0) {
		        $average =  number_format( $A['total']/$A['count'], 2 );
		        $v = RATING_rating_as_html($average,$score_max, $function_flag);
		    } else {
		        ($anon_user_can_rate) ? $v = $LANG_RATING[105] : $v = ''; // "Not yet rated";
		    }
		  }
			$t->set_var('item_rating', $v);
			$t->parse('average', 'rating');
		}
		else
		{
			$t->parse('average', '');
		}
	
		// ****************************************************
		// Reviews Section
		// check any ratings exist
		
		If ($A['count'] > 0 && RATING_function_in_flag($function_flag, CONST_FLAG_REVIEWS_VIEW))  // Allow viewing of reviews
		{
			$t->set_var('lang_review_view', $LANG_RATING[117]);  // 
			$t->set_var('title', $LANG_RATING[103]);  // View Reviews
			$t->set_var('rt_id', $item_id);
			$t->parse('view_item', 'review_view', true);
		}
	
		// Check submission table as well
		if ($rated == 0) {$rated = RATING_check_user_rated($item_id, $user_id, $ipaddress,true);}
		If (($rated == 0) && RATING_function_in_flag($function_flag, CONST_FLAG_REVIEWS_ADD))  // Allow adding of reviews
		{
			
			if ($anon_user_can_rate AND !$owner_same_parent) {
				$t->set_var('lang_review_add', $LANG_RATING[118]);   // Add
				$t->set_var('title', $LANG_RATING[104]); // Add a Review
			} else {
				$t->set_var('lang_review_add', '');   // Add
				$t->set_var('title', ''); // Add a Review
			}
			$t->set_var('rt_id', $item_id);
			$t->parse('add_item', 'review_add', true);
		}
		// ****************************************************
	
		// *********************************************
		// Admin Section
		if ($display_text_details)
		{
		  $sql = 'SELECT COUNT(*) AS count, owner_id, group_id, perm_owner, perm_group, '
		       . "perm_members, perm_anon FROM {$_TABLES['rating_totals']} WHERE (rt_id = '$item_id') "
		       . COM_getPermSQL('AND') 
		       . 'GROUP BY rt_id';
		  $result = DB_query ($sql);
		  $B = DB_fetchArray ($result);
		  $allowed = $B['count'];
		
		  if ( $allowed >= 1 ) {
		  	
		      $edit_option = ( SEC_hasRights( 'rating.edit' ) &&
		          ( SEC_hasAccess( $B['owner_id'], $B['group_id'],
		              $B['perm_owner'], $B['perm_group'], $B['perm_members'],
		              $B['perm_anon'] ) == 3 ) );
		      
		      if ($edit_option) {
			      $edit_url = '<a href="' . $_CONF['site_admin_url']
			       . '/plugins/rating/index.php?mode=edit&amp;rt_id=' . $item_id 
			       . '">' . $LANG01[04] . '</a>';
			       
			       $t->set_var('edit_option', $edit_url);
					}
			} else {
					$t->set_var('edit_option', '');
			}
		} else {
				$t->set_var('edit_option', '');
		}
		// *********************************************
	
	
		$t->parse('output','page');
	  $retval = $t->finish($t->get_var('output'));

	  return $retval;
}


/**
* 
* RATING_rating_as_html
* 
* given a value, returns HTML for a rating as a number or as an image
* 
* takes values $r   - user rating
*              $max - maximum possible score for item
* 
*/
function RATING_rating_as_html($r, $max, $function_flag='0')
{
    global $_CONF, $_RATING_CONF;
        	
    $temp_flag = $function_flag;
    
    for ( $counter = 1; $counter <= 2; $counter += 1) {                  
      If (RATING_function_in_flag($temp_flag, CONST_FLAG_RATING_AS_TEXT) || $temp_flag == CONST_FLAG_RATING_AS_TEXT) {
				$retval = $r;
	      break;
	    } else If (RATING_function_in_flag($temp_flag, CONST_FLAG_RATING_AS_DIGG) || $temp_flag == CONST_FLAG_RATING_AS_DIGG) {
				$retval = number_format( $r, 0 );
	    	break;
			} elseIf (RATING_function_in_flag($temp_flag, CONST_FLAG_RATING_AS_STARS) || $temp_flag == CONST_FLAG_RATING_AS_STARS) {
				$retval = RATING_build_starline($r, $max);
				break;          
			} else {// NOT TOLD use default
				$temp_flag = $_RATING_CONF['average_rating_default_display'];
	    }
		}
		
    return $retval;
}


/**
* 
* RATING_build_starline
* 
* given a value, returns HTML for that rating as a row of stars
* 
* takes values $r   - rating to convert
*              $max - maximum possible score for item
* 
*/
function RATING_build_starline($r, $max)
{
  global $_CONF, $_RATING_CONF;

    $t = new Template($_CONF['path'] . 'plugins/rating/templates');
    $t->set_file( array( 'page'=>'ratingstarpage.thtml',
                       'image'=>'ratingstaritem.thtml'));
    $t->set_var('site_url', $_CONF['site_url']);
  
    $t->set_var('title_text', '');

	// code is modified from harpia project http://sf.net/projects/harpia

	// Break up score
	if (strpos($r,".")==0)
	{
		$full_stars=$r;
	}
	else
	{
		$full_stars=substr($r,0,strpos($r,"."));
	}

	// *** Is there half star
	if (substr($r,strpos($r,".")+1)==0)
	{
		$half_stars=0;
	}
	else
	{
		$half_stars=1;
	}

	// *** Build Star Line
	$blank_stars=$max-($full_stars+$half_stars);
	for ($i=1;$i<=$max;$i++)
	{

		if ($i<=$full_stars)
		{
			$t->set_var('img', 'rate_full');
			$t->parse('item', 'image', true);
		}
		elseif ($i<=($half_stars+$full_stars))
		{
			$t->set_var('img', 'rate_half');
			$t->parse('item', 'image', true);
		}
		elseif ($i<=$max)
		{
			$t->set_var('img', 'rate_none');
			$t->parse('item', 'image', true);
		}
	}
    $t->parse('output','page');
    $retval = $t->finish($t->get_var('output'));

    return $retval;

}

/**
* 
* RATING_save_rating_totals
*       item_id
*       item_type
*       score_min
*       score_max
*       user_id
* saves new rating information (to be used as defaults, etc..)
* 
*/

function RATING_save_rating_totals($rt_id, $item_type, $item_type_id, $score_min, $score_max)
{
  global $_TABLES, $_RATING_CONF;

	if (trim($item_type) != '') {
	  if (!RATING_new_total($rt_id)) {
	      $user_id = $_RATING_CONF['rating_owner_auto_created'];
	  	
	      if (isset ($_GROUPS['Rating Admin'])) {
	          $group_id = $_GROUPS['Rating Admin'];
	      } else {
	          $group_id = SEC_getFeatureGroup ('rating.edit');
	      }
		    $A = array ();
		    SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_totals']);        
	      $perm_owner = $A['perm_owner'];
	      $perm_group = $A['perm_group'];
	      $perm_members = $A['perm_members'];
	      $perm_anon = $A['perm_anon'];      
	          	
	      $total = DB_query("INSERT INTO {$_TABLES['rating_totals']} (rt_id, item_type, item_id, score_min, score_max, count, total, created, owner_id, group_id,perm_owner,perm_group,perm_members,perm_anon) VALUES ('{$rt_id}', '{$item_type}', '{$item_type_id}', '{$score_min}', '{$score_max}', '0', '0', NOW(), '{$user_id}', '{$group_id}','{$perm_owner}', '{$perm_group}', '{$perm_members}', '{$perm_anon}')");
	  }
	}
	
  return;
}

/**
* 
* RATING_save_rating
*       item_id
*       item_type
*       score
*       score_min
*       score_max
*       user_id
*       ipaddress
* saves new rating
* 
*/

function RATING_save_rating($item_id, $score, $user_id, $ipaddress)
{
  global $_TABLES, $_RATING_CONF;
  

  
  if ($user_id == '' OR $user_id < '2')
  {
		if ($_RATING_CONF['ratingloginrequired'] == 1) {
			return false;
		} else {
    	$user_id = "1";
    }
  }
  if (RATING_check_user_rated($item_id, $user_id, $ipaddress) OR RATING_owner_same_parent_item($item_id, $user_id))
  {
  	return false;
  }
  else
  {
    $rid = COM_makeSid();
    if (isset ($_GROUPS['Rating Admin'])) {
        $group_id = $_GROUPS['Rating Admin'];
    } else {
        $group_id = SEC_getFeatureGroup ('rating.edit');
    }
    $A = array ();
    SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_ratings']);        
    $perm_owner = $A['perm_owner'];
    $perm_group = $A['perm_group'];
    $perm_members = $A['perm_members'];
    $perm_anon = $A['perm_anon'];      
    
    $item = DB_query("INSERT INTO {$_TABLES['rating']} (rid, rt_id, created, score, ipaddress, owner_id, group_id,perm_owner,perm_group,perm_members,perm_anon) VALUES ('{$rid}', '{$item_id}', NOW(), '{$score}', '{$ipaddress}', '{$user_id}', '{$group_id}','{$perm_owner}', '{$perm_group}', '{$perm_members}', '{$perm_anon}')");
    $total = DB_query("UPDATE {$_TABLES['rating_totals']} SET count=count+1, total=total+{$score} WHERE (rt_id='{$item_id}')");
  }
  return true;
}


/**
* 
* RATING_list_ratings
*       item_id
*       start_date
*       end_date
*       format
* returns array of data for ratings in defined period of time
* 
*/
function RATING_list_ratings($item_id, $start_date, $end_date, $format)
{

    // to be done
    return "list";

}


function RATING_owner_same_parent_item($rt_id, $user_id)
{
  global $_TABLES, $_RATING_CONF;
  

    if ($_RATING_CONF['rate_own_item'] == 0 AND $user_id > '1') {
    	$bypass = false;
	
			$sql = "SELECT item_type, item_id, title FROM {$_TABLES['rating_totals']} WHERE rt_id = '" . $rt_id . "'";
		  $result = DB_query ($sql);
		  $arr = DB_fetchArray ($result);   
		  
		  if ($arr['item_type'] <> '') {
		    switch (strtolower($arr['item_type']))
		    {
		        case 'staticpage':
		        		$temptable = $_TABLES['staticpage'];
		        		$temptableid = 'sp_id';
		        		$temptableownerid = 'owner_id';
		            break;
		        case 'story':
		        		$temptable = $_TABLES['stories'];
		        		$temptableid = 'sid';
		        		$temptableownerid = 'uid';
		        		break;
		        case 'comment':
		        		$temptable = $_TABLES['comments'];
		        		$temptableid = 'cid';
		        		$temptableownerid = 'uid';
		            break;
		        case 'user':
		        		$temptable = $_TABLES['users'];
		        		$temptableid = 'uid';
		        		$temptableownerid = 'uid';
		        		break;
		        default:
		        		//not a valid type bypass check
		        		$bypass = true;
		        		break;
    		}	
    		
				if (!$bypass) {
					$sql = "SELECT {$temptableownerid} userid FROM {$temptable} WHERE {$temptableid} = '" . $arr['item_id'] . "' AND {$temptableownerid} = '{$user_id}'";
				  
				  $result = DB_query ($sql);
				  $arr2 = DB_fetchArray ($result);   
				  
				  if ($arr2['userid'] == $user_id) {
				  	return true;
				  }
				}
			}     		
		}

    return false;
}

/**
* 
* RATING_check_user_rated         (see if a user has already rated an item)
*        item_type
*        user_id
*        ipaddress
* returns array of rating data if exists, false if not
* 
*/
function RATING_check_user_rated($rt_id, $user_id, $ipaddress, $submission = false)
{
    global $_TABLES, $_USER, $_RATING_CONF;
    if ($submission)
    {
    	$table = $_TABLES['ratingsubmission'];
    } else {
    	$table = $_TABLES['rating'];
    }
    
    if ($user_id > 1)
    {
        $where = "owner_id='{$user_id}' AND rt_id='{$rt_id}'";
    }
    else
    {
        $where = "ipaddress='{$ipaddress}' AND rt_id='{$rt_id}' AND owner_id='1'";
    }
    $check = DB_getItem($table, 'score', $where);
    if (isset($check))
    {
        return $check;
    }

    return false;
}



/**
* 
* RATING_new_total
* 
* tells if an item has a total score already or not
* 
*/
function RATING_new_total($id)
{
    global $_TABLES;
    $check = DB_getItem($_TABLES['rating_totals'], 'total', "rt_id='{$id}'");
    if (isset($check))
    {
        return true;
    }
    else
    {
        return false;
    }
}


/**
* 
* RATING_get_average
* 
* returns array of rating information for an item
* array total => total score (sum of all ratings)
*       count => number of ratings that made up that total
* 
*/
function RATING_get_total_count($id)
{
    global $_TABLES;
    $result = DB_Query("SELECT total, count FROM {$_TABLES['rating_totals']} WHERE rt_id='{$id}'");
    $A = DB_fetchArray($result);
    return $A;
}


/**
* 
* RATING_item_deleted
* 
* an item has been deleted, so delete all ratings too
* 
* called with RATING_delete_item($sid, 'story'); on line 946 of lib-story.php
* 
*/

// this needs work - need an API to allow plugins to control who can delete what 

function RATING_delete_item($id)
{
    global $_TABLES;
//    if ( ($type=='story' && SEC_hasRights('story.edit')) ||
//         ($type=='staticpages' && SEC_hasRights('staticpages.delete') )
//    {
        DB_Delete($_TABLES['rating_totals'],'rt_id',$id);
        DB_Delete($_TABLES['rating'],'rt_id',$id);
//    }
    return;
}


/**
 * 
 * RATING_delete_user
 * 
 * remove all ratings by a particular user
 * 
 * called with RATING_delete_user($owner_id); on line 142 of lib-user.php
 * 
 */
function RATING_delete_user($user_id) {
    global $_TABLES;
    if (SEC_hasRights ('user.delete'))
    {
        $result = DB_Query("SELECT rt_id FROM {$_TABLES['rating']} WHERE owner_id='{$user_id}'");
        DB_Delete($_TABLES['rating'],'owner_id',$user_id);
        while ($A = DB_fetchArray($result)) {
            RATING_rebuild_totals($A['rt_id']);
        }
    }
    return;
}


/**
 * 
 * RATING_rebuild_total
 * 
 * rebuild rating total for rt_id = $id (needed after removing all ratings by
 * a particular user)
 * 
 */
function RATING_rebuild_totals($id)
{
    global $_TABLES;
    
    $result = DB_Query("SELECT IFNULL(SUM(score),0) AS total,COUNT(*) AS count FROM {$_TABLES['rating']} WHERE rt_id='{$id}'");
    $A = DB_fetchArray($result);

    DB_Query("UPDATE {$_TABLES['rating_totals']} SET total='{$A['total']}', count='{$A['count']}' WHERE rt_id='{$id}'");

    return;
}



/**
 * 
 * rating_remove_user_ratings
 * 
 * remove all ratings by a particular user
 * 
 */
function RATING_remove_user_ratings($user_id)
{
  global $_TABLES;
  $result = DB_Query("SELECT rt_id FROM {$_TABLES['rating']} WHERE owner_id='{$user_id}'");
  DB_Delete($_TABLES['rating'],'owner_id',$user_id);
  while ($A = DB_fetchArray($result)) {
    RATING_rebuild_totals($A['rt_id']);
  }
  return;
}

/**
 * 
 * rating_plugin_api
 * 
 **/

function RATING_plugin_api ()
{

//  get all plugins from db
//  loop through all
//    check for existence of pluginname_rating_enabled
//    if returns true, then plugin supports rating
//  end loop

// show this list on rating admin page to enable/disable ratings

return ;

}

/**
 * 
 * rating_plugin_api
 * 
 **/
function RATING_display_rating_total($rt_id, $url, $preview = false)
{
  global $_CONF, $_TABLES, $_RATING_CONF, $LANG_RATING;

  $t = new Template($_CONF['path'] . 'plugins/rating/templates');
  $t->set_file( array( 'page'=>'rating_info.thtml' ));
  
  $sql = "SELECT * FROM " . $_TABLES['rating_totals'] . " WHERE rt_id = '$rt_id'";
  $result = DB_query ($sql);
  $A = DB_fetchArray ($result);

  $t->set_var('lang_rating_details', $LANG_RATING[108]);

	if (rating_rt_is_digg($rt_id)) {
	  $t->set_var('lang_average', $LANG_RATING[331]);
	  $t->set_var('lang_average_display', RATING_display_rating($rt_id,'','','','', (CONST_FLAG_RATING_VIEW + CONST_FLAG_RATING_AS_DIGG), false));
		
	} else { 	
	  $t->set_var('lang_average', $LANG_RATING[110]);
	  $t->set_var('lang_average_display', RATING_display_rating($rt_id,'','','','', (CONST_FLAG_RATING_VIEW + CONST_FLAG_RATING_AS_STARS), false));
	}
  if( $A['banner_link'] == '' || $preview ) {
    $t->set_var( 'hide_no_banner', 'style="display:none"' );
  } else {
  	$t->set_var( 'hide_no_banner', '' );
    $t->set_var( 'banner_info', $A['banner_link'] );
  }
  
  if( $A['title_link'] == '' ) {
    $t->set_var( 'hide_no_review_for', 'style="display:none"' );
  } else {
  	$t->set_var( 'hide_no_review_for', '' );
  	$t->set_var( 'lang_review_for', $LANG_RATING[340]);
    $t->set_var( 'review_for', $A['title_link'] );
  }

  if( $A['title'] == '' ) {
    $t->set_var( 'hide_no_title', 'style="display:none"' );
  } else {
  	$t->set_var( 'hide_no_title', '' );
	  $t->set_var('lang_title', $LANG_RATING[106]);
	  $t->set_var('lang_title_display', $A['title']);      
  }

  if( $A['comment'] == '' ) {
    $t->set_var( 'hide_no_comment_for', 'style="display:none"' );
  } else {
  	$t->set_var( 'hide_no_comment_for', '' );
	  $t->set_var('lang_comment', $LANG_RATING[107]);
	  $t->set_var('lang_comment_display', $A['comment']);
  }
	
	/*
	// Link to Rating Location
	$t->set_var('lang_link', $LANG_RATING[62]);
	$t->set_var( 'start_storylink_anchortag', '<a href="'
	          . $url . '" class="non-ul">' );
	$t->set_var( 'story_title', $LANG_RATING[203]);
	$t->set_var( 'end_storylink_anchortag', '</a>' );
	*/

  $t->set_var('lang_number', $LANG_RATING[109]);
  $t->set_var('lang_number_display', $A['count']);

	$t->parse('output','page');
  $retval = $t->finish($t->get_var('output'));

	return $retval;
	
}
function RATING_return_rate_digg ($name = 'score', $id = '' )
{
	global $LANG_RATING, $_RATING_CONF, $_CONF;

	$retval = '';
	
	if ($id != '') {
		$retval .= '<form style="display: inline;" action="' . $_CONF["site_url"] . '/rating/rate.php" method="post">';
		$retval .= '<input type="hidden" value="' . $id . '" name="id">';
	}
	
	$retval .= '<input type="hidden" value="1" name="' . $name . '">';
	
	if ($id != '') {
		if ($_RATING_CONF['use_image_buttons'] == 1) {
			$retval .= '&nbsp;<input type="image" value="' . $LANG_RATING[330] . '" name="mode" border="0" src="'. $_CONF['site_url'] . '/rating/images/diggbutton.gif">';
		} else {
			$retval .= '&nbsp;<input type="submit" value="' . $LANG_RATING[330] . '" name="mode">';
		}
		
		$retval .= '</form>&nbsp;';
	}	
	
	return $retval;	
}

function RATING_return_rate_combo ($min, $max, $score = 1, $name = 'score', $id = '' )
{
	global $_CONF, $LANG_RATING, $_RATING_CONF;

	$retval = '';
	
	if ($id != '') {
		$retval .= '<form style="display: inline;" action="' . $_CONF["site_url"] . '/rating/rate.php" method="post">';
		$retval .= '<input type="hidden" value="' . $id . '" name="id">';
	}
	
	$retval .= '<select name="' . $name . '">';
  for ($i = $min; $i <= $max; $i++) {
  	if ($i == $score)
  	{
  		$selected = 'selected';
  	} else {
  		$selected = '';
  	}
		$retval .= '<option ' . $selected . '>' . $i. '</option>';
	}
	$retval .= '</select>';
	
	if ($id != '') {
		if ($_RATING_CONF['use_image_buttons'] == 1) {
			$retval .= '&nbsp;<input type="image" value="' . $LANG_RATING[313] . '" name="mode" border="0" src="{$_CONF["site_url"]}/rating/images/savebutton.gif">';
		} else {
			$retval .= '&nbsp;<input type="submit" value="' . $LANG_RATING[313] . '" name="mode">';
		}
		$retval .= '</form>&nbsp;';
	}	
	
	return $retval;
	
}
function RATING_display_rating($rt_id, $type = '', $type_id = '', $min = '', $max = '', $function_flag = 0, $display_text_details = true )
{
  global $_CONF, $_TABLES, $_RATING_CONF, $LANG_RATING, $_USER;

	$default_minmax = false;
	$error_flag = false;
	
	$uid = $_USER['uid'];
		
	// do some basic checks for min & max
	if (is_numeric($min) AND is_numeric($max))
	{
		if ($min > $max)
		{
			$default_minmax = true;
		}
	} else {
		$default_minmax = true;
	}
	If ($default_minmax == true) {
		// Check if exist then used default in db else use config settings
		If (DB_count($_TABLES['rating_totals'],'rt_id',$rt_id) == 1 )
		{
			
			$min = DB_getItem($_TABLES['rating_totals'], 'score_min', "rt_id='$rt_id'");
			$max = DB_getItem($_TABLES['rating_totals'], 'score_max', "rt_id='$rt_id'");
		} else {
			$min = $_RATING_CONF['score_min'];
			$max = $_RATING_CONF['score_max'];
		}
	}	
	// basic checks for flag
	settype($function_flag, "integer");
	
	// do a DIGG check if min = max then over ride for DIGG rating
	if (($min == $max) OR RATING_function_in_flag($function_flag, CONST_FLAG_RATING_AS_DIGG))
	{
		$min = 1;
		$max = 1;
		if (!RATING_function_in_flag($function_flag, CONST_FLAG_RATING_AS_DIGG)) {
			$function_flag = $function_flag + CONST_FLAG_RATING_AS_DIGG;
		}
	}
	
	// check for errors in function flag
	if (!RATING_function_in_flag($function_flag))
	{
		$error_flag = true;
	}

	$retval = '';
  if ($error_flag)
  {
  	$retval = $LANG_RATING['error'];
	} else {
		
		// Save rating record if autocreated (ie users, stories, etc..)
		if ($type !='autotagged') {
			RATING_save_rating_totals($rt_id, $type, $type_id, $min, $max);
		}

		// Security Check
   $sql = 'SELECT COUNT(*) AS count, owner_id, group_id, perm_owner, perm_group, '
         . "perm_members, perm_anon FROM {$_TABLES['rating_totals']} WHERE (rt_id = '$rt_id') "
         . COM_getPermSQL('AND') 
         . 'GROUP BY rt_id';
    $result = DB_query ($sql);
    $B = DB_fetchArray ($result);
    $allowed = $B['count'];

    if ( $allowed >= 1 ) {
        $view_flag = ( SEC_hasRights( 'rating.view' ) OR
            ( SEC_hasAccess( $B['owner_id'], $B['group_id'],
                $B['perm_owner'], $B['perm_group'], $B['perm_members'],
                $B['perm_anon'] ) >= 2 ) );
			if ($view_flag) {
	    	$retval = RATING_return_form($rt_id, $min, $max, $function_flag, $display_text_details );
	    }
    }
  }  
  
  return $retval;	
}


// +---------------------------------------------------------------------------+
// | Moderation plugin functions                                                   |
// +---------------------------------------------------------------------------+

/**
*
* Counts the items that are submitted
*
*/
function plugin_submissioncount_rating ()
{
   global $_TABLES;

    // Need to check to see if table exists for when you upgrade from 1.0 this will fail
    $result = DB_query("show tables like '{$_TABLES['ratingsubmission']}'");
    $N = DB_fetchArray( $result );
    $exist = $N[0];	 

    If ($exist <> '') {
   		return DB_count ($_TABLES['ratingsubmission']);
   	}
}

/**
*
* Checks that the current user has the rights to moderate the
* plugin, returns true if this is the case, false otherwise
*
* @return        boolean       Returns true if moderator
*
*/
function plugin_ismoderator_rating ()
{
    return SEC_hasRights ('rating.moderate');
}


/**
* Returns SQL & Language texts to moderation.php
*/
function plugin_itemlist_rating ()
{
    global $_TABLES, $LANG_RATING;

    if (plugin_ismoderator_rating ()) {
        $plugin = new Plugin();
        $plugin->submissionlabel = $LANG_RATING[10];
        $plugin->submissionhelpfile = 'ccratingsubmission.html';
        $plugin->getsubmissionssql = "SELECT rs.rid AS id,CONCAT(rt.title,' | ',rs.title) AS title,rs.score,CONCAT(LEFT(LTRIM(rs.comment),100),' ...') 
        	FROM {$_TABLES['ratingsubmission']} rs, {$_TABLES['rating_totals']} rt
        	WHERE rt.rt_id = rs.rt_id
        	ORDER BY title ASC";
        $plugin->addSubmissionHeading($LANG_RATING[64]);
        $plugin->addSubmissionHeading($LANG_RATING[52]);
        $plugin->addSubmissionHeading($LANG_RATING[53]);
        

        return $plugin;
    }
}


/**
* returns list of moderation values
*
* The array returned contains (in order): the row 'id' label, main plugin
* table, moderation fields (comma seperated), and plugin submission table
*
* @return       array        Returns array of useful moderation values
*
*/
function plugin_moderationvalues_rating ()
{
    global $_TABLES;

    return array ('rid',
                  $_TABLES['rating'],
                  'rid,rt_id,created,score,nickname,location,title,pros,cons,bottomline,comment,owner_id,ipaddress',
                  $_TABLES['ratingsubmission']);
}


/**
* Performs plugin exclusive work for items approved by moderation
*
* While moderation.php handles the actual move from linkssubmission
* to links tables, within the function we handle all other approval
* relate tasks
*
* @param      string       $id      Identifying string
* @return     string       Any wanted HTML output
*
*/
function plugin_moderationapprove_rating ($id)
{
    global $_TABLES, $_USER, $_GROUPS, $_RATING_CONF;

    $result = DB_query( "SELECT * FROM {$_TABLES['rating']} WHERE rid = '$id'" );
    $N = DB_fetchArray( $result );
    $rt_id = $N['rt_id'];
    $owner_id = $N['owner_id'];
    $ipaddress = $N['ipaddress'];
    $score = $N['score'];

		// Delete any old records since this may be a resubmit
		$sqlstring = "DELETE FROM {$_TABLES['rating']} WHERE rid <> '$id' AND rt_id = '$rt_id' AND owner_id = $owner_id";
		if ($owner_id == 1) {
			$sqlstring .= " AND ipaddress = '$ipaddress'";
		}
		$result = DB_query( $sqlstring );
		
    $A = array ();
    SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_ratings']); 

	  if (isset ($_GROUPS['Rating Admin'])) {
	      $group_id = $_GROUPS['Rating Admin'];
	  } else {
	      $group_id = SEC_getFeatureGroup ('rating.edit');
	  }
    DB_query ("UPDATE {$_TABLES['rating']} SET 
    group_id=$group_id,
    perm_owner={$A['perm_owner']},
    perm_group={$A['perm_group']},
    perm_members={$A['perm_members']},
    perm_anon={$A['perm_anon']}
    
    WHERE rid = '$id'");

    
    DB_query ("UPDATE {$_TABLES['rating_totals']} SET 
    count = count+1, total=total+$score 
    WHERE rt_id = '$rt_id'");

    return '';
}

/**
* Performs plugin exclusive work for items deleted by moderation
*
* While moderation.php handles the actual removal from <plugin>submission
* table, within this function we handle all other deletion
* relate tasks
*
* @param      string       $id      Identifying string
* @return     string       Any wanted HTML output
*
*/
function plugin_moderationdelete_rating ($id)
{
    global $_TABLES;

		
    // these tables should not contain any rows with ml_id = $id
    // this is done 'just in case'
    DB_delete ($_TABLES['ratingsubmission'], 'rid', $id);


    return '';
}

/**
* Check submission form values and save if OK. Else show form again
*
*/
function plugin_savesubmission_rating ($A)
{
		// Not Used...

    return $retval;
}

/**
* Shows rating submission form
*
*/
function plugin_submit_rating ()
{
		// Not Used...
            
    return $display;

}

/**
* Saves a review submission
*
* @param    array   $A  Data for that submission
* @return   string      HTML redirect
*
*/
function plugin_save_submit_rating ($A)
{
		// Not Used...


    return $retval;
}


/**
* Used with admin page
*
* @param    array   $A  Data for that submission
* @return   string      HTML redirect
*
*/
function plugin_getListField_rating ($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $_CONF, $LANG_ADMIN, $LANG_ACCESS, $LANG_RATING, $_RATING_CONF;
    $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
    if ($access > 0) {
        switch($fieldname) {
            case "edit":
                $retval = "<center><a href=\"{$_CONF['site_admin_url']}/plugins/rating/index.php?mode=edit&amp;rt_id={$A['rt_id']}\">{$icon_arr['edit']}</a></center>";
                break;
            case "view_ratings":
            		if ($A['count'] == 0 )
            		{
            			$retval = "";
            		} else {
	                $retval = "<center><a href=\"{$_CONF['site_url']}/rating/review.php?rt_id={$A['rt_id']}&amp;mode=view\"><img src=\"/rating/images/view.gif\" width=16 height=16 border=0></a></center>";
	              }
	              
                break;
            case "title":
                // $retval = RATING_return_parent_info ($A['rt_id'], '', false);
                
								$title = RATING_return_parent_info($A['rt_id'], '', false);
								$rt_link = RATING_return_parent_info($A['rt_id'], '', true);
								if ($rt_link != '') {
									$retval = "<a href=" .  $rt_link . ">{$title}</a>";
								} else {
									$retval = $title;
								} 
								                
                break;
            case "info":
                $retval = $A['comment'];
                break;
            case "count":
                $retval = $A['count'];
                break;
            case "average":
						    if ($A['count'] > 0)
						    {
		            		if (rating_rt_is_digg($A['rt_id'])) {
		            			$count = $A['count'];
		            			$average = RATING_rating_as_html($count,$A['score_max'], (CONST_FLAG_RATING_AS_DIGG));
		            		} else {
							        $average =  number_format( $A['total']/$A['count'], 2 );
							        
							        $average = RATING_rating_as_html($average,$A['score_max'], CONST_FLAG_RATING_AS_STARS);
										}
						    }
						    else
						    {
						        $average = ''; // $LANG_RATING[105]; // "Not yet rated";
						    }

								

                $retval = $average;
                break;                
            case "access":
                if ($access == 3) {
                   $retval = $LANG_ACCESS['edit'];
                } else {
                   $retval = $LANG_ACCESS['readonly'];
                }
                break;
            default:
            		// Group and item_type
                $retval = $fieldvalue;
                break;
        }
    }
    return $retval;
}

/**
* Used with list page
*
* @param    array   $A  Data for that submission
* @return   string      HTML redirect
*
*/
function plugin_getListField_rating_list ($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $_CONF, $LANG_ADMIN, $LANG_ACCESS, $LANG_RATING, $_RATING_CONF, $_TABLES;
    $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
    if ($access > 0) {
    	
        switch($fieldname) {
            case "view_ratings":
            		$retval = "";
            		
            		if ($A['count'] > 0 )
            		{
            			// check if review text is present
							    $result = DB_query("SELECT rt_id FROM {$_TABLES['rating']} WHERE rt_id='{$A['rt_id']}' AND comment IS NOT NULL");
							    $nrows = DB_numRows($result);            			
            			If ($nrows > 0) {
	                	$retval = "<center><a href=\"{$_CONF['site_url']}/rating/review.php?rt_id={$A['rt_id']}&amp;mode=view\"><img src=\"/rating/images/view.gif\" width=16 height=16 border=0></a></center>";
	                }
	              }
	              
                break;
            case "title":
                // $retval = RATING_return_parent_info ($A['rt_id'], '', false);
                
								$title = RATING_return_parent_info($A['rt_id'], '', false);
								$rt_link = RATING_return_parent_info($A['rt_id'], '', true);
								if ($rt_link != '') {
									$retval = "<a href=" .  $rt_link . ">{$title}</a>";
								} else {
									$retval = $title;
								}                
                
                break;
            case "count":
                $retval = $A['count'];
                break;
            case "total":
                $retval = $A['total'];
                break;
            case "average":
						    if ($A['count'] > 0)
						    {
		            		if (rating_rt_is_digg($A['rt_id'])) {
		            			$count = $A['count'];
		            			$average = RATING_rating_as_html($count,$A['score_max'], (CONST_FLAG_RATING_AS_DIGG));
		            		} else {
							        $average =  number_format( $A['total']/$A['count'], 2 );
							        
							        $average = RATING_rating_as_html($average,$A['score_max'], CONST_FLAG_RATING_AS_STARS);
										}
						    }
						    else
						    {
						        $average =  $LANG_RATING[105]; // "Not yet rated";
						    }

								

                $retval = $average;
                break;                
            default:
            		// Group and item_type
                $retval = $fieldvalue;
                break;
        }
    }
    return $retval;
}


function rating_rt_is_digg ($rt_id)
{
	global $_TABLES;
	
	$retval = false;

  $result = DB_query("SELECT score_min, score_max FROM {$_TABLES['rating_totals']} WHERE rt_id = '" . $rt_id . "'");
  $A = DB_fetchArray($result);

  if (($A['score_min'] == 1 ) AND ($A['score_max'] == 1)) { $retval = true;}
	
	return $retval;
}
/**
* Return a list of all item_types categories
*
* @param    string  $current_category   currently selected category
* @return   string                      <option> list containing all categories
*
* Note: $current_category will be returned as an empty string when found in the
*       current list of categories and left untouched when it's a new category,
*       i.e. the user selected "Other". This is needed for moderating link
*       submissions.
*
*/
function rating_get_item_type_list (&$current_item_type, $All_flag = false)
{
    global $_TABLES, $LANG_RATING;

    $retval = '';

    $result = DB_query("SELECT DISTINCT item_type FROM {$_TABLES['rating_totals']} GROUP BY item_type");
    $nrows = DB_numRows($result);

		if ($All_flag) {
			$retval = '<option value="' . $LANG_RATING[361] . '">' . $LANG_RATING[361] . '</option>';
		} else {
    	$retval = '<option value="' . $LANG_RATING[319] . '">' . $LANG_RATING[319] . '</option>';
    }
    
    for ($i = 0; $i < $nrows; $i++) {
        $A = DB_fetchArray ($result);
        $item_type = $A['item_type'];
        $retval .= '<option value="' . $item_type . '"';
        if ($item_type == $current_item_type) {
            $retval .= ' selected="selected"';
            $current_item_type = '';
        }
        $retval .= '>' . $item_type . '</option>';
    }

    return $retval;
}



/**
* Geeklog is asking us to provide any new items that show up in the type
* drop-down on search.php.  Let's users search for links.
*
*/

function plugin_searchtypes_rating ()
{
    global $LANG_RATING;

    $tmp['rating'] = $LANG_RATING[52];

    return $tmp;
}


/**
* This searches for links matching the user query and returns an array of
* for the header and table rows back to search.php where it will be formated and
* printed
*
* @param    string  $query      Keywords user is looking for
* @param    date    $datestart  Start date to get results for
* @param    date    $dateend    End date to get results for
* @param    string  $topic      The topic they were searching in
* @param    string  $type       Type of items they are searching, or 'all'
* @param    int     $author     Get all results by this author
* @param    string  $keyType    search key type: 'all', 'phrase', 'any'
* @param    int     $page       page number of current search
* @param    int     $perpage    number of results per page
*
*/

function plugin_dopluginsearch_rating ($query, $datestart, $dateend, $topic, $type, $author, $keyType, $page, $perpage)
{
    global $_CONF, $_TABLES, $LANG_RATING_SEARCH, $_RATING_CONF;

    // Make sure the query is SQL safe
    $query = trim(addslashes($query));

    $sql = "SELECT rid AS id, title, comment AS description, created AS date, owner_id AS uid, '' AS hits, ";
    $sql .= "CONCAT('/rating/review.php?rt_id=', rt_id, '&mode=view') AS url ";
    $sql .= "FROM {$_TABLES['rating']} WHERE 1 = 1 ";
    $sql .= COM_getPermSQL('AND') . ' ';

    $search = new SearchCriteria('rating', $LANG_RATING_SEARCH['results']);

    $columns = array('title', 'comment');
    list($sql,$ftsql) = $search->buildSearchSQL($keyType, $query, $columns, $sql);

    $search->setSQL($sql);
    $search->setFTSQL($ftsql);
    $search->setRank(3);

    return $search;
}


function rating_sendNotification ($item, $title, $rating, $comment, $rt_id)
{
    global $_CONF, $_TABLES, $LANG_RATING, $LANG08;
    
    $title = stripslashes ($title);
    $comment = stripslashes ($comment);

		$mailbody = "$LANG_RATING[106]: $title\n"
              . "$LANG_RATING[52]: $rating\n\n"
              . $comment . "\n\n";

    $mailbody .= "$LANG_RATING[325] <{$_CONF['site_admin_url']}/moderation.php>\n\n";

    $mailsubject = $_CONF['site_name'] . ' ' . $LANG_RATING[10] . $item;

    $mailbody .= "\n------------------------------\n";
    $mailbody .= "\n$LANG08[34]\n";
    $mailbody .= "\n------------------------------\n";

    COM_mail ($_CONF['site_mail'], $mailsubject, $mailbody);
}


/**
* Upgrade to current version of rating.
*
*
*/
function plugin_upgrade_rating()
{
	global $_TABLES;
	
	$res = DB_query( "SELECT pi_version FROM {$_TABLES['plugins']} WHERE pi_name = 'rating'" );
	$row = DB_fetchArray( $res, false );
	
	COM_errorLog( "Updating rating plugin from v" . $row['pi_version'] . ' to v' . plugin_chkVersion_rating(), 1 );
	
	return rating_doUpgrades( $row['pi_version'] );
}

function rating_doUpgrades( $current_rating_version )
{
	global $_TABLES, $_CONF, $_DB;

	$_DB->setDisplayError( true );

	$done = false;

	while ( $done == false )
	{
		switch ( $current_rating_version )
		{
			case '1.0':
			{
			}
			case '1.0b2':
			{
			}
			case '1.0b':
			{
				unset($_SQL);
				require_once( $_CONF['path'] . 'plugins/rating/sql/updates/rating_1.0_to_2.0beta.php' );

				for ( $i = 1; $i <= count( $_SQL ); $i++ )
				{
					DB_query( current( $_SQL ) );
					next( $_SQL );
				}

				RATING_fix_group_id();

				$current_rating_version = '2.0beta';
			}
				break;
			
			case '2.0beta':                          
				unset($_SQL); 
				
				require_once( $_CONF['path'] . 'plugins/rating/sql/updates/rating_2.0beta_to_2.1beta.php' );

				for ( $i = 1; $i <= count( $_SQL ); $i++ )
				{
					DB_query( current( $_SQL ) );
					next( $_SQL );
				}
			
				$current_rating_version = '2.1beta';
				break;
			case '2.1beta':
				unset($_SQL); 
				
				require_once( $_CONF['path'] . 'plugins/rating/sql/updates/rating_2.1beta_to_2.2beta.php' );

				for ( $i = 1; $i <= count( $_SQL ); $i++ )
				{
					DB_query( current( $_SQL ) );
					next( $_SQL );
				}

				$current_rating_version = '2.2beta';
			  break;
			case '2.2beta':
				$current_rating_version = '2.3.0';
			  break;
            case '2.3.0':
                $current_rating_version = '2.3.1';
              break;
			default:
				$done = true;
				break;
		}
	}

	DB_query( "UPDATE {$_TABLES['plugins']} SET pi_version = '{$current_rating_version}' WHERE pi_name = 'rating'" );
	
	return true;
}

function plugin_profilevariablesdisplay_rating ($uid, &$template)
{
    global $_TABLES, $_CONF, $_RATING_CONF;
    
    if ($_RATING_CONF[rate_users]) {
			$template->set_var( 'rating',  RATING_display_rating($uid, 'user', $uid, $_RATING_CONF[rate_users_min], $_RATING_CONF[rate_users_max], $_RATING_CONF[rate_users_function_flag] ) );
		}
}


function rating_admin_menu($text_arr, $menu_arr = '')
{
    global $_CONF;

    $retval = '';

    $help_url = "";
    if (!empty($text_arr['help_url'])) {
        $help_url = $text_arr['help_url'];
    }
    
    $title = "";
    if (!empty($text_arr['title'])) {
        $title = $text_arr['title'];
    }

    $icon = '';
    if (isset($text_arr['icon'])) {
        $icon = $text_arr['icon'];
    }

	$admin_templates = new Template ($_CONF['path'] . 'plugins/rating/templates/admin/');
    $admin_templates->set_file (array ('top_menu' => 'top_menu.thtml',
                                       'menufields' => 'menufields.thtml'
                                      ));    
    
	if (isset ($text_arr['icon']) && ($text_arr['icon'] !== false)) {
			$admin_templates->set_var('icon', "<img src=\"{$text_arr['icon']}\" alt=\"\">");
		}


    if ($text_arr['has_menu']) {
        for ($i = 0; $i < count($menu_arr); $i++) {
            $admin_templates->set_var('menu_url', $menu_arr[$i]['url'] );
            $admin_templates->set_var('menu_text', $menu_arr[$i]['text'] );
            if ($i < (count($menu_arr) -1)) {
                $admin_templates->set_var('line', '|' );
            }
            $admin_templates->parse('menu_fields', 'menufields', true);
            $admin_templates->clear_var('line');
        }
    }
    $admin_templates->set_var('lang_instructions', $text_arr['instructions']);
    $admin_templates->parse('output', 'top_menu', true);    

    $retval .= $admin_templates->finish($admin_templates->get_var('output'));

    return $retval;

}


?>