<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Rating plugin 2.0 for Geeklog                                             |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | functions.inc                                                             |
// |                                                                           |
// | config file for the Rating plugin for Geeklog.                         |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright  (C) 2006 Euan McKay  - info AT heatherengineering DOT com      |
// | Copyright  (C) 2006 Tom Homer	 - TomHomer AT cogeco DOT com              |
// | For support and information, visit http://www.heatherengineering.com/     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//



require_once ('../lib-common.php');


// CHECK ACCESS RIGHTS TO RATING PAGE

if (!SEC_hasRights('rating.view')) {
    $page  = COM_siteHeader('menu');
    $page .= COM_startBlock($LANG_RATING['userstats']);
    $page .= $LANG_RATING['noaccess'];
    $page .= COM_endBlock();
    $page .= COM_siteFooter();
}



function RATING_list_user_ratings()
{
    global $_USER, $_CONF, $_TABLES, $LANG_RATING;
    
    $t = new Template($_CONF['path'] . 'plugins/rating/templates');
    $t->set_file( array( 'page' => 'user.thtml',
                         'item' => 'userrating.thtml'));
    $t->set_var('site_url', $_CONF['site_url']);

    $sql = "SELECT * FROM {$_TABLES['rating']}
            LEFT JOIN {$_TABLES['rating_totals']} ON {$_TABLES['rating']}.rt_id = {$_TABLES['rating_totals']}.rt_id
            WHERE {$_TABLES['rating']}.uid='{$_USER['uid']}'";
    $result = DB_query($sql);
    $nrows  = DB_numRows ($result);
    $retval ="";
    
    $t->set_var('lang_id', 'ID');
    $t->set_var('lang_type', 'item_type');
    $t->set_var('lang_average', 'total');
    $t->set_var('lang_your_rating', 'score');
    $t->set_var('lang_total', 'score_max');
    $t->set_var('lang_delete', 'delete');

    
    if ($nrows > 0) {
        for ($i = 0; $i < $nrows; $i++) {
            $A = DB_fetchArray($result);
            $t->set_var('id', $A['rid']);
            $t->set_var('type', $A['item_type']);
            $t->set_var('average', $A['total']/$A['count']);
            $t->set_var('your_rating', $A['score']);
            $t->set_var('total', $A['score_max']);
            $t->set_var('rid', $A['rid']);
            $t->set_var('delete', 'delete');
            $t->parse('ratings', 'item', true);
        }
	    $t->parse('output','page');
        $retval = $t->finish($t->get_var('output'));
    } else {
        $retval .= COM_startBlock($LANG_RATING['userstats']);
        $retval .= $LANG_RATING['nouserstats'];
        $retval .= COM_endBlock();
    }

    return $retval;

}


function RATING_delete_user_item($rid)
{
    global $_USER, $_TABLES, $LANG_RATING;

    $result = DB_Query("SELECT rt_id,uid FROM {$_TABLES['rating']} WHERE rid='{$rid}'");
    $A = DB_fetchArray($result);

    if ($A['uid'] == $_USER['uid'])
    {
        DB_Delete($_TABLES['rating'],'rid',$rid);
    }

    RATING_rebuild_totals($A['rt_id']);
    return "deleted item";

}

$action = COM_applyFilter($_REQUEST['action']);
$rid = COM_applyFilter($_REQUEST['rid']);
$ipaddress = $_SERVER['REMOTE_ADDR'];
$page ="";

// MAIN

$page .= COM_siteHeader('menu');

//if ($action == "delete")
//{
//    $msg = RATING_delete_user_item($rid);
//    $page .= $msg;
//}

//$page .= RATING_list_user_ratings();
$page .= "User Page not enabled for this version of the Ratings Plugin.";
$page .= COM_siteFooter();

echo $page;

?>