<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Rating plugin 2.0 for Geeklog                                             |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | functions.inc                                                             |
// |                                                                           |
// | config file for the Rating plugin for Geeklog.                         |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright  (C) 2006 Euan McKay  - info AT heatherengineering DOT com      |
// | Copyright  (C) 2006 Tom Homer	 - TomHomer AT cogeco DOT com              |
// | For support and information, visit http://www.heatherengineering.com/     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


require_once ('../lib-common.php');
//require_once ('../auth.inc.php');



function list_rating_totals ()
{
    global $_CONF, $_TABLES, $LANG_ADMIN, $LANG_RATING, $LANG_RATING_STATS, $LANG_ACCESS, $_IMAGE_TYPE,$LANG28;
    
    require_once( $_CONF['path_system'] . 'lib-admin.php' );
    
    $retval = '';

    $header_arr = array(      # dislay 'text' and use table field 'field'
                    //array('text' => $LANG_RATING[301], 'field' => 'view_ratings', 'sort' => false),
                    array('text' => $LANG_RATING[106], 'field' => 'title', 'sort' => true),
                    //array('text' => $LANG_RATING[302], 'field' => 'item_type', 'sort' => true),
                    array('text' => $LANG_RATING[306], 'field' => 'count', 'sort' => true),
                    array('text' => $LANG_RATING_STATS['stats_hits'], 'field' => 'total', 'sort' => true),
                    array('text' => $LANG_RATING[334], 'field' => 'average', 'sort' => true));
                    

    $defsort_arr = array('field' => 'title', 'direction' => 'asc');

                          
    $text_arr = array('has_extras'   => true,
                      'title' => $LANG_RATING_STATS['stats_page_title'], 'instructions' => $LANG_RATING[360],
                      //'icon' =>  $_CONF['site_url'] . '/rating/images/rating.png',
                      'form_url' => $_CONF['site_url'] . "/rating/list.php");
    
    $filter = '';
    $othercategory = '';
    if (isset ($_POST['select_itemtype'])) {
    	if ($_POST['select_itemtype'] != $LANG_RATING[361] AND $_POST['select_itemtype'] != '') {
				$filter = 'AND item_type ="' .  addslashes($_POST['select_itemtype']) . '"';
				$othercategory = $_POST['select_itemtype'];
			}
		}
    $query_arr = array('table' => 'rating_totals',
                       'sql' => "SELECT *, (total/count) average FROM {$_TABLES['rating_totals']} WHERE 1",
                       'query_fields' => array('title', 'item_type', 'comment'), 
                       'default_filter' => COM_getPermSql ('AND') . $filter);

	$option_list = rating_get_item_type_list($othercategory, true);    

    $filter .= '<span style="padding-right:20px;">';
    $filter .= '<label for="select_itemtype">' . $LANG_RATING[302] . ': ' . '
			<select id="select_itemtype" name="select_itemtype">'
			. $option_list .
			'</select>';
    
    $filter .= $LANG28[48] . '</label></span>';

    $retval .= ADMIN_list ('rating', 'plugin_getListField_rating_list', $header_arr, $text_arr,
                            $query_arr, $defsort_arr);
    return $retval;

}



// MAIN


$display = '';

// CHECK ACCESS RIGHTS TO RATING PAGE
/*
if (!SEC_hasRights('rating.view')) {
    $display  = COM_siteHeader('menu');
    $display .= COM_startBlock($LANG_RATING[359]);
    $display .= $LANG_RATING['noaccess'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();

    echo $display;
    exit;    
}
*/

$display .= COM_siteHeader ('menu', $LANG_RATING[304]);
if (isset ($_REQUEST['msg'])) {
    $msg = COM_applyFilter ($_REQUEST['msg'], true);
    if ($msg > 0) {
        $display .= COM_showMessage ($msg, 'rating');
    }
}    
             
$display .= list_rating_totals();

$display .= COM_siteFooter ();

echo $display;


?>