<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Rating plugin for Geeklog                                                 |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | review.php                                                                |
// |                                                                           |
// | review.php file for the Rating plugin for Geeklog.                        |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright  (C) 2006 Euan McKay  - info AT heatherengineering DOT com      |
// | Copyright  (C) 2006 Tom Homer	 - TomHomer AT cogeco DOT com              |
// | For support and information, visit http://www.heatherengineering.com/     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


/**
* Geeklog common function library
*/
require_once('../lib-common.php');


// Uncomment the line below if you need to debug the HTTP variables being passed
// to the script.  This will sometimes cause errors but it will allow you to see
// the data being passed in a POST operation
// echo COM_debug($_POST);

/**
 * Hanldes a comment submission
 *
 * @copyright Vincent Furia 2005
 * @author Vincent Furia <vinny01 AT users DOT sourceforge DOT net>
 * @return string HTML (possibly a refresh)
 */
function handleSubmit() 
{
    global $_POST, $_TABLES, $_CONF, $LANG03;

    $rt_id = COM_applyFilter ($_POST['rt_id']);

    $ret = save_review ($_POST['nickname'], $_POST['location'], strip_tags ($_POST['title']), $_POST['pros'], $_POST['cons'], $_POST['bottomline'],
        COM_applyFilter ($_POST['score'], true), $_POST['comment'], $rt_id, 
        COM_applyFilter ($_POST['postmode']));

    if ( $ret > 0 ) {  // failure //FIXME: some failures should not return to review form
        $display .= COM_siteHeader()

            . review_form ($_POST['nickname'], $_POST['location'], strip_tags ($_POST['title']), $_POST['pros'], $_POST['cons'], $_POST['bottomline'], $_POST['score'], $_POST['comment'], $rt_id, 
                               $LANG03[14], $_POST['postmode'], $url)
            . COM_siteFooter();
    } else if ( $ret == -1 ) {  // success user has mod access therefore insert directly into rating table
    	$display = COM_refresh ($_CONF['site_url'] . '/index.php?msg=4&plugin=rating');
    } else { // success, rating submitted for approval
        $display = COM_refresh ($_CONF['site_url'] . '/index.php?msg=1&plugin=rating');
    }

    return $display;
}

/**
 * Hanldes a comment submission
 *
 * @copyright Vincent Furia 2005
 * @author Vincent Furia <vinny01 AT users DOT sourceforge DOT net>
 * @return string HTML (possibly a refresh)
 */
 
function updatehelpful($helpful, $url) {
    global $_REQUEST, $_TABLES, $_RATING_CONF, $LANG_RATING;


    COM_clearSpeedlimit ($_RATING_CONF['ratingspeedlimit'], 'review_helpful');

    $last = COM_checkSpeedlimit ('review_helpful');

    if ($last > 0) {
				$retval .= COM_siteHeader();    	
        $retval .= COM_startBlock ($LANG12[26], '',
                           COM_getBlockTemplate ('_msg_block', 'header'))
            . $LANG_RATING[350]
            . $last
            . $LANG_RATING[327]
            . $_RATING_CONF['ratingspeedlimit']
            . $LANG_RATING[351]
            . COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
				$retval .= COM_siteFooter();        
    } else {

	    $rid = COM_applyFilter ($_REQUEST['rid']);
	
			if ($helpful) {
				$column = 'helpful_yes';
			} else {
				$column = 'helpful_no';
			}
	    
	    // now update totals
	    $helpfulcount = DB_getItem($_TABLES['rating'], $column, "rid='$rid'");
	    DB_Query("UPDATE {$_TABLES['rating']} SET {$column}={$column}+1 WHERE rid='{$rid}'");
	    
	    COM_updateSpeedlimit ('review_helpful');
	    
  		$retval .= handleView($url);  // moved to function for readibility

		}

		return $retval;

}
 
function handleDelete($url) {
    global $_REQUEST, $_TABLES, $_CONF;

    $rid = COM_applyFilter ($_REQUEST['rid']);
    $rt_id = COM_applyFilter ($_REQUEST['rt_id']);

    $has_editPermissions = SEC_hasRights ('rating.edit');
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['rating']} WHERE rid = '$rid'");
    $A = DB_fetchArray ($result);

    if ($has_editPermissions && SEC_hasAccess ($A['owner_id'],
            $A['group_id'], $A['perm_owner'], $A['perm_group'],
            $A['perm_members'], $A['perm_anon']) == 3) {
         	
        
        // now update totals
        $reviewscore = DB_getItem($_TABLES['rating'], 'score', "rid='$rid'");
        DB_Query("UPDATE {$_TABLES['rating_totals']} SET total=total-$reviewscore, count=count-1 WHERE rt_id='{$rt_id}'");
        // now delete record
        DB_Delete($_TABLES['rating'],'rid',$rid);
        
				RATING_rebuild_totals ($rt_id);
        
        $display .= COM_refresh ($url);
    } else {
        COM_errorLog ("User {$_USER['username']} (IP: {$_SERVER['REMOTE_ADDR']}) "
                    . "tried to illegally delete rating $rid");
        $display .= COM_refresh ($_CONF['site_url'] . '/index.php');
    }

    return $display;
}
/**
* Displays the review form
*
* @param    string  $title      Title of comment
* @param    string  $comment    Text of comment
* @param    string  $rt_id        ID of object review belongs to
* @param    string  $mode       Mode, e.g. 'preview'
* @param    string  $postmode   Indicates if comment is plain text or HTML
* @return   string  HTML for comment form
*
*/
function review_form($nickname, $location, $title, $pros, $cons, $bottomline, $rating, $comment, $rt_id, $mode, $postmode, $url) 
{
    global $_CONF, $_TABLES, $_USER, $LANG03, $LANG12, $LANG_LOGIN, $LANG_RATING, $_RATING_CONF;

    $retval = '';

    // never trust $uid ...
    if (empty ($_USER['uid'])) {
        $uid = 1;
    } else {
        $uid = $_USER['uid'];
    }

		// Check if user already has a rating on this item (in submission or actual)
		if (($mode != 'edit' && $mode != $LANG03[14]) && (RATING_check_user_rated($rt_id, $uid, $_SERVER['REMOTE_ADDR']) > 0))
		{
			return COM_refresh ($_CONF['site_url'] . '/index.php?msg=2&plugin=rating');
		} else {
			// Check if user already has a submission already pending
			if (RATING_check_user_rated($rt_id, $uid, $_SERVER['REMOTE_ADDR'],true) > 0)
			{
				return COM_refresh ($_CONF['site_url'] . '/index.php?msg=3&plugin=rating');
		  } else {
		  	if (RATING_owner_same_parent_item($rt_id, $uid)) {
		  		return COM_refresh ($_CONF['site_url'] . '/index.php?msg=9&plugin=rating');
		  	}
			}
		}

    if (empty($_USER['username']) &&
        (($_CONF['loginrequired'] == 1) || ($_RATING_CONF['ratingloginrequired'] == 1))) {
        $retval .= COM_startBlock ($LANG_LOGIN[1], '',
                           COM_getBlockTemplate ('_msg_block', 'header'));
        $loginreq = new Template($_CONF['path_layout'] . 'submit');
        $loginreq->set_file('loginreq', 'submitloginrequired.thtml');
        $loginreq->set_var('login_message', $LANG_LOGIN[2]);
        $loginreq->set_var('site_url', $_CONF['site_url']);
        $loginreq->set_var('lang_login', $LANG_LOGIN[3]);
        $loginreq->set_var('lang_newuser', $LANG_LOGIN[4]);
        $loginreq->parse('errormsg', 'loginreq');
        $retval .= $loginreq->finish($loginreq->get_var('errormsg'));
        $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        return $retval;
    } else {
        COM_clearSpeedlimit ($_RATING_CONF['ratingspeedlimit'], 'rating');

        $last = COM_checkSpeedlimit ('rating');

        if ($last > 0) {
            $retval .= COM_startBlock ($LANG12[26], '',
                               COM_getBlockTemplate ('_msg_block', 'header'))
                . $LANG_RATING[326]
                . $last
                . $LANG_RATING[327]
                . $_RATING_CONF['ratingspeedlimit']
                . $LANG_RATING[328]
                . COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        } else {

            if (($_CONF['advanced_editor'] == 1) && file_exists ($_CONF['path_layout'] . 'rating/reviewform_advanced.thtml')) {
                $postmode = 'html';
            } elseif (empty ($postmode)) {
                $postmode = $_CONF['postmode'];
            }

            $sig = '';
            if ($uid > 1) {
                $sig = DB_getItem ($_TABLES['users'], 'sig', "uid = '$uid'");
            }

            // Note:
            // $comment / $newcomment is what goes into the preview / is
            // actually stored in the database -> strip HTML
            // $commenttext is what the user entered and goes back into the
            // <textarea> -> don't strip HTML

            $commenttext = htmlspecialchars (COM_stripslashes ($comment));

            $fakepostmode = $postmode;
            if ($postmode == 'html') {
                $comment = COM_checkWords (COM_checkHTML (COM_stripslashes ($comment)));
            } else {
                $comment = htmlspecialchars (COM_checkWords (COM_stripslashes ($comment)));
                $newcomment = COM_makeClickableLinks ($comment);
                if (strcmp ($comment, $newcomment) != 0) {
                    $comment = nl2br ($newcomment);
                    $fakepostmode = 'html';
                }
            }
            // Replace $, {, and } with special HTML equivalents
            $commenttext = str_replace('$','&#36;',$commenttext);
            $commenttext = str_replace('{','&#123;',$commenttext);
            $commenttext = str_replace('}','&#125;',$commenttext);

            $title = COM_checkWords (strip_tags (COM_stripslashes ($title)));
            // $title = str_replace('$','&#36;',$title); done in CMT_getComment

            $_POST['title'] = $title;
            $newcomment = $comment;
            if (!empty ($sig)) {
                if (($postmode == 'html') || ($fakepostmode == 'html')) {
                    $newcomment .= '<p>---<br>' . nl2br ($sig);
                } else {
                    $newcomment .= LB . LB . '---' . LB . $sig;
                }
            }
            $_POST['comment'] = $newcomment;
						
						// Preview mode
						if ($mode == $LANG03[14] && !empty($title) && !empty($comment) ) {
						    $start = new Template($_CONF['path'] . 'plugins/rating/templates');
                $start->set_file( array( 'comment' => 'startreview.thtml' ));
                $start->set_var( 'site_url', $_CONF['site_url'] );
                $start->set_var( 'layout_url', $_CONF['layout_url'] );
                $start->set_var( 'hide_if_preview', 'style="display:none"' );

                if (empty ($_POST['username'])) {
                    $_POST['username'] = DB_getItem ($_TABLES['users'],
                            'username', "uid = $uid");
                }
                $thecomments = get_review ($_POST,'ASC', $url, false, true );
                $start->set_var( 'comments', $thecomments );
                
                $retval .= COM_startBlock ($LANG03[14])
                        . $start->finish( $start->parse( 'output', 'comment' ))
                        . COM_endBlock ();
            // Preview mode
            } else if ($mode == $LANG03[14]) {
                $retval .= COM_startBlock ($LANG03[17], '',
                               COM_getBlockTemplate ('_msg_block', 'header'))
                    . $LANG_RATING[61]
                    . COM_endBlock(COM_getBlockTemplate ('_msg_block', 'footer'));
                $mode = 'error';
            }

            $comment_template = new Template($_CONF['path'] . 'plugins/rating/templates');
            if (($_CONF['advanced_editor'] == 1) && file_exists ($_CONF['path_layout'] . 'rating/reviewform_advanced.thtml')) {
                $comment_template->set_file('form','reviewform_advanced.thtml');
            } else {
                $comment_template->set_file('form','reviewform.thtml');
            }
            $comment_template->set_var('site_url', $_CONF['site_url']);
            $comment_template->set_var('start_block_postareview', COM_startBlock($LANG_RATING[50]));
            $comment_template->set_var('lang_username', $LANG03[5]);
            $comment_template->set_var('rt_id', $rt_id);
            $comment_template->set_var('url', $url);

            if (!empty($_USER['username'])) {
            		$uid = $_USER['uid'];
                $comment_template->set_var('uid', $uid);
                $comment_template->set_var('username', $_USER['username']);
                $comment_template->set_var('action_url', $_CONF['site_url'] . '/users.php?mode=logout');
                $comment_template->set_var('lang_logoutorcreateaccount', $LANG03[03]);
            } else {
            		$uid = 1;
                $comment_template->set_var('uid', $uid);
                $comment_template->set_var('username', $LANG03[24]);
                $comment_template->set_var('action_url', $_CONF['site_url'] . '/users.php?mode=new'); 
                $comment_template->set_var('lang_logoutorcreateaccount', $LANG03[04]);
            }

            if ($postmode == 'html') {
                $comment_template->set_var ('show_texteditor', 'none');
                $comment_template->set_var ('show_htmleditor', '');
            } else {
                $comment_template->set_var ('show_texteditor', '');
                $comment_template->set_var ('show_htmleditor', 'none');
            }

						// Post rating totals information
						if ($mode == $LANG03[14]) {
							$preview = true;
						} else {
							$preview = false;
						}
						$comment_template->set_var('ratingtotalsinfo', RATING_display_rating_total($rt_id, $url, $preview));

		        if( $uid > 1 ) {
		            $comment_template->set_var( 'hide_if_user', 'style="display:none"' );
		        } else {
		            $comment_template->set_var( 'hide_if_user', '' );
		            $comment_template->set_var('lang_nickname', $LANG_RATING[338]);
		            $comment_template->set_var('nickname', htmlspecialchars($nickname));
		        }
					
						$comment_template->set_var('lang_location', $LANG_RATING[339]);
						$comment_template->set_var('location', htmlspecialchars($location));

            $comment_template->set_var('lang_title', $LANG_RATING[51]);
            $comment_template->set_var('title', htmlspecialchars($title));
            
            $comment_template->set_var('lang_pros', $LANG_RATING[335]);
            $comment_template->set_var('pros', htmlspecialchars($pros));
            $comment_template->set_var('lang_cons', $LANG_RATING[336]);
            $comment_template->set_var('cons', htmlspecialchars($cons));
            $comment_template->set_var('lang_bottomline', $LANG_RATING[337]);
            $comment_template->set_var('bottomline', htmlspecialchars($bottomline));
            
            $comment_template->set_var('lang_rating', $LANG_RATING[52]);
            //$comment_template->set_var('rating', htmlspecialchars($rating));
            $result = DB_query( "SELECT score_min,score_max FROM {$_TABLES['rating_totals']} WHERE rt_id = '$rt_id'" );
		        $N = DB_fetchArray( $result );
		        $min = $N['score_min'];
		        $max = $N['score_max'];
            $comment_template->set_var('rating', RATING_return_rate_combo($min,$max, $rating, 'score'));
            
            
            $comment_template->set_var('lang_review', $LANG_RATING[53]);
            $comment_template->set_var('comment', $commenttext);
            $comment_template->set_var('lang_postmode', $LANG03[2]);
            $comment_template->set_var('postmode_options', COM_optionList($_TABLES['postmodes'],'code,name',$postmode));
            $comment_template->set_var('allowed_html', COM_allowedHTML());
            $comment_template->set_var('lang_importantstuff', $LANG_RATING[55]);
            $comment_template->set_var('lang_instr_line1', $LANG_RATING[56]);        
            $comment_template->set_var('lang_instr_line2', $LANG_RATING[57]);        
            $comment_template->set_var('lang_instr_line3', $LANG_RATING[58]);        
            $comment_template->set_var('lang_instr_line4', $LANG_RATING[59]);        
            $comment_template->set_var('lang_instr_line5', $LANG_RATING[60]);        
            $comment_template->set_var('lang_instr_line6', $LANG_RATING[61]);        
            $comment_template->set_var('lang_instr_line7', $LANG_RATING[63]);        
            $comment_template->set_var('lang_preview', $LANG03[14]);

            if (($_CONF['skip_preview'] == 1) || ($mode == $LANG03[14])) {
                $comment_template->set_var('save_option', '<input type="submit" name="mode" value="' . $LANG_RATING[54] . '">');
            }

            $comment_template->set_var('end_block', COM_endBlock());        
            $comment_template->parse('output', 'form');
            $retval .= $comment_template->finish($comment_template->get_var('output'));
        }
    }

    return $retval;
}
/**
* This function displays the comment control bar
*
* Prints the control that allows the user to interact with Geeklog Comments
*
* @param        string      $rt_id        ID of item in question
* @param        string      $title      Title of item
* @param        string      $order      Order that comments are displayed in
* @see CMT_userComments
* @see CMT_commentChildren
* @return     string   HTML Formated comment bar
*
*/
function review_bar( $rt_id, $title, $order, $url )
{
    global $_CONF, $_TABLES, $_USER, $LANG01, $_REQUEST, $LANG_RATING;

    $parts = explode( '/', $_SERVER['PHP_SELF'] );
    $page = array_pop( $parts );
    $nrows = DB_count( $_TABLES['rating'], 'rt_id', $rt_id );

    //$commentbar = new Template( $_CONF['path_layout'] . 'comment' );
    $commentbar = new Template($_CONF['path'] . 'plugins/rating/templates');
    $commentbar->set_file( array( 'commentbar' => 'reviewbar.thtml' ));
    $commentbar->set_var( 'site_url', $_CONF['site_url'] );
    $commentbar->set_var( 'layout_url', $_CONF['layout_url'] );

    $commentbar->set_var( 'lang_reviews', $LANG_RATING[201] );
    $commentbar->set_var( 'lang_refresh', $LANG01[39] );
    $commentbar->set_var( 'lang_disclaimer', $LANG_RATING[202] );

    $commentbar->set_var( 'num_reviews', COM_numberFormat( $nrows ));
    $commentbar->set_var( 'comment_type', $type );
    $commentbar->set_Var( 'rt_id', $rt_id );


		// Link to Rating Location
		$rt_link = RATING_return_parent_info($rt_id, $url, true);
		$commentbar->set_var( 'start_storylink_anchortag', '<a href="' . $rt_link . '">' );
    $commentbar->set_var( 'story_title', $LANG_RATING[203]);
		$commentbar->set_var( 'end_storylink_anchortag', '</a>' );


		// User
    if( !empty( $_USER['uid'] ) && ( $_USER['uid'] > 1 )) {
    		$uid = $_USER['uid'];
        $username = $_USER['username'];
        $fullname = DB_getItem( $_TABLES['users'], 'fullname',
                                "uid = '{$_USER['uid']}'" ); 
    } else {
        $result = DB_query( "SELECT username,fullname FROM {$_TABLES['users']} WHERE uid = 1" );
        $N = DB_fetchArray( $result );
        $username = $N['username'];
        $fullname = $N['fullname'];
        $uid = 1;
    }
    
    if( empty( $fullname )) {
        $fullname = $username;
    }
    $commentbar->set_var( 'user_name', $username );   
    $commentbar->set_var( 'user_fullname', $fullname );    

    if( !empty( $_USER['username'] )) {
        $commentbar->set_var( 'user_nullname', $username );
        $commentbar->set_var( 'login_logout_url',
                              $_CONF['site_url'] . '/users.php?mode=logout' );
        $commentbar->set_var( 'lang_login_logout', $LANG01[35] );
    } else {
        $commentbar->set_var( 'user_nullname', '' );
        $commentbar->set_var( 'login_logout_url',
                              $_CONF['site_url'] . '/users.php?mode=new' );
        $commentbar->set_var( 'lang_login_logout', $LANG01[61] );
    }
		
		// Edit a Review total
    if ($uid > 1) {
	    $sql = 'SELECT COUNT(*) AS count, owner_id, group_id, perm_owner, perm_group, '
	         . "perm_members, perm_anon FROM {$_TABLES['rating_totals']} WHERE (rt_id = '" . $rt_id . "') "
	         . 'AND (created <= NOW())' . COM_getPermSQL('AND') 
	         . 'GROUP BY rt_id';
	    $result = DB_query ($sql);
	    $B = DB_fetchArray ($result);
	    $allowed = $B['count'];
	
	    if ( $allowed >= 1 ) {
	        $access = SEC_hasAccess( $B['owner_id'], $B['group_id'],
	                $B['perm_owner'], $B['perm_group'], $B['perm_members'],
	                $B['perm_anon'] );    
	        if ($access == 3) {$UserFlag = true;}
      }
		}  		
		If ($UserFlag)   // Allow adding of reviews
		{
			$editoption = " | <a href=\"{$_CONF['site_admin_url']}/plugins/rating/index.php?mode=edit&amp;rt_id={$rt_id}\">" . $LANG01[04] . "</a>";
		} else {
			$editoption ='';
		}		
		$commentbar->set_var( 'edit_option', $editoption );
		
		// Add a Review
    $ipaddress = $_SERVER['REMOTE_ADDR'];
		$rated = RATING_check_user_rated($rt_id, $uid, $ipaddress,false);
		if ($rated == 0) {$rated = RATING_check_user_rated($rt_id, $uid, $ipaddress,true);}
		If ($rated == 0)   // Allow adding of reviews
		{
			$addoption = ' | <a href="' . $_CONF['site_url'] . '/rating/review.php?rt_id=' . $rt_id . '">' . $LANG_RATING[104] . '</a> ';
		} else {
			$addoption ='';
		}
		$commentbar->set_var( 'add_option', $addoption );

		// Rating Information
		$commentbar->set_var('ratingtotalsinfo', RATING_display_rating_total($rt_id, $url));

    $commentbar->set_var( 'parent_url', 
                          $_CONF['site_url'] . '/rating/review.php' );
    $hidden = '';
    $hidden .= '<input type="hidden" name="rt_id" value="' . $_REQUEST['rt_id'] . '">';
    $commentbar->set_var( 'hidden_field', $hidden . 
            '<input type="hidden" name="mode" value="' . $_REQUEST['mode'] . '">' );



    // Order
    $selector = '<select name="order">' . LB
              . COM_optionList( $_TABLES['sortcodes'], 'code,name', $order )
              . LB . '</select>';
    $commentbar->set_var( 'order_selector', $selector);


    return $commentbar->finish( $commentbar->parse( 'output', 'commentbar' ));
}    

/**
* This function displays the comments in a high level format.
*
* Begins displaying user comments for an item
*
* @param        string      $rt_id       ID for rating to show reviews for
* @param        string      $title     Title of item
* @param        string      $order     How to order the comments 'ASC' or 'DESC'
* @param        int         $page      page number of comments to display
* @param        boolean     $delete_option   if current user can delete comments
* @see function CMT_commentBar
* @see function CMT_commentChildren
* @return     string  HTML Formated Comments
*
*/
function user_reviews( $rt_id, $title, $order='', $page = 1, $delete_option = false, $url )
{
    global $_CONF, $_TABLES, $_USER, $LANG01, $_RATING_CONF;

		$limit = $_RATING_CONF['ratinglimit'];
		
		If (empty($order))
		{
			$order = $_RATING_CONF['ratingorder'];
		}
    if( $order != 'ASC' && $order != 'DESC' ) {
        $order = 'ASC';
    }

    if( empty( $limit )) {
        $limit = 10;
    }
    
    if( !is_numeric($page) || $page < 1 ) {
        $page = 1;
    }

    $start = $limit * ( $page - 1 );

    $template = new Template($_CONF['path'] . 'plugins/rating/templates');
    $template->set_file( array( 'commentarea' => 'startreview.thtml' ));
    $template->set_var( 'site_url', $_CONF['site_url'] );
    $template->set_var( 'layout_url', $_CONF['layout_url'] );
    $template->set_var( 'commentbar',
                        review_bar( $rt_id, $title, $order, $url));
    $template->set_var( 'rt_id', $rt_id );
    
    
    // build query
    $count = DB_count( $_TABLES['rating'], 'rt_id', $rt_id );

    $q = "SELECT r.*, u.username, u.fullname, u.photo, " 
         . "unix_timestamp(r.created) AS nice_date "
       . "FROM {$_TABLES['rating']} as r, {$_TABLES['users']} as u "
       . "WHERE r.owner_id = u.uid AND r.rt_id = '$rt_id' "
       . COM_getPermSql ('AND')
       . "ORDER BY created $order LIMIT $start, $limit";

    $thecomments = '';
    $result = DB_query( $q );

    $thecomments .= get_review ($result, $order, $url, $delete_option );

    // Pagination
    $tot_pages =  ceil( $count / $limit );
    //$pLink = $_CONF['site_url'] . "/article.php?story=$sid&amp;type=$type&amp;order=$order&amp;mode=$mode";
    $pLink = $_CONF['site_url'] . "/rating/review.php?rt_id=$rt_id&amp;order=$order&amp;mode=view&amp;url=$url";
    $template->set_var( 'pagenav',
                     COM_printPageNavigation($pLink, $page, $tot_pages));
    
    $template->set_var( 'comments', $thecomments );
    $retval = $template->parse( 'output', 'commentarea' );

    return $retval;
}

/**
 * Save a review
 *
 * @param    string      $title      Title of comment
 * @param    string      $comment    Text of comment
 * @param    string      $sid        ID of object receiving comment
 * @param    string      $postmode   Indicates if text is HTML or plain text
 * @return   int         0 for success, > 0 indicates error
 *
 */
function save_review ($nickname, $location, $title, $pros, $cons, $bottomline, $rating, $comment, $rt_id, $postmode) 
{
    global $_CONF, $_TABLES, $_USER, $_SERVER, $LANG03, $_RATING_CONF;

    $ret = 0;

    // Get a valid uid
    if (empty ($_USER['uid'])) {
        $uid = 1;
    } else {
        $uid = $_USER['uid'];
        //$nickname ='';
    }

    // Sanity check
    if (empty ($rt_id) || empty ($title) || empty ($comment) || empty ($rating) ) {
        COM_errorLog("save_review: $uid from {$_SERVER['REMOTE_ADDR']} tried "
                   . 'to submit a review with one or more missing values.');
        return $ret = 1;
    }

    // Check that anonymous comments are allowed
    if (($uid == 1) && (($_CONF['loginrequired'] == 1) 
            || ($_RATING_CONF['ratingloginrequired'] == 1))) {
        COM_errorLog("save_review: IP address {$_SERVER['REMOTE_ADDR']} "
                   . 'attempted to save a review with anonymous comments disabled for site.');
        return $ret = 2;
    }

    // Check for people breaking the speed limit
    COM_clearSpeedlimit ($_RATING_CONF['ratingspeedlimit'], 'rating');
    $last = COM_checkSpeedlimit ('rating');
    if ($last > 0) {
        COM_errorLog("save_review: $uid from {$_SERVER['REMOTE_ADDR']} tried "
                   . 'to submit a review before the speed limit expired');
        return $ret = 3;
    }

    // Let plugins have a chance to check for SPAM
    $result = PLG_checkforSpam($comment, $_CONF['spamx']);
    // Now check the result and display message if spam action was taken
    if ($result > 0) {
        // update speed limit nonetheless
        COM_updateSpeedlimit ('rating');

        // then tell them to get lost ...
        COM_displayMessageAndAbort ($result, 'spamx', 403, 'Forbidden');
    }

    // Clean 'em up a bit!
    if ($postmode == 'html') {
        $comment = COM_checkWords (COM_checkHTML (COM_stripslashes ($comment)));
    } else {
        $comment = htmlspecialchars (COM_checkWords (COM_stripslashes ($comment)));
        $newcomment = COM_makeClickableLinks ($comment);
        if (strcmp ($comment, $newcomment) != 0) {
            $comment = nl2br ($newcomment);
            $postmode = 'html';
        }
    }
    $title = COM_checkWords (strip_tags (COM_stripslashes ($title)));
    $nickname = COM_checkWords (strip_tags (COM_stripslashes ($nickname)));
    $location = COM_checkWords (strip_tags (COM_stripslashes ($location)));
    $pros = COM_checkWords (strip_tags (COM_stripslashes ($pros)));
    $cons = COM_checkWords (strip_tags (COM_stripslashes ($cons)));
    $bottomline = COM_checkWords (strip_tags (COM_stripslashes ($bottomline)));

    // Get signature
    $sig = '';
    if ($uid > 1) {
        $sig = DB_getItem($_TABLES['users'],'sig', "uid = '$uid'");
    }
    if (!empty ($sig)) {
        if ($postmode == 'html') {
            $comment .= '<p>---<br>' . nl2br($sig);
        } else {
            $comment .= LB . LB . '---' . LB . $sig;
        }
    }

    if (!empty ($title) && !empty ($comment)) {
        COM_updateSpeedlimit ('rating');
        $title = addslashes ($title);
        $nickname = addslashes ($nickname);
        $location = addslashes ($location);
        $pros = addslashes ($pros);
        $cons = addslashes ($cons);
        $bottomline = addslashes ($bottomline);
        $comment = addslashes ($comment);
        $rid = COM_makeSid();

				// See if user submitting has rating moderation privilages is so insert directly
		    $has_editPermissions = SEC_hasRights ('rating.moderate');
		    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['rating_totals']} WHERE rt_id = '$rt_id'");
		    $A = DB_fetchArray ($result);
		
		    if ($has_editPermissions && SEC_hasAccess ($A['owner_id'],
		            $A['group_id'], $A['perm_owner'], $A['perm_group'],
		            $A['perm_members'], $A['perm_anon']) == 3) {
					
					$A['owner_id'] = $uid;
					SEC_setDefaultPermissions ($A, $_RATING_CONF['default_permissions_ratings']); 
					
					// Since has mod rights insert directly into rating table
					DB_save ($_TABLES['rating'], 'rid,rt_id,created,score,nickname,location,title,pros,cons,bottomline,comment,ipaddress, owner_id, group_id,perm_owner,perm_group,perm_members,perm_anon',
	                    "'$rid','$rt_id',now(),$rating,'$nickname','$location','$title','$pros','$cons','$bottomline','$comment','{$_SERVER['REMOTE_ADDR']}', '{$A['owner_id']}', '{$A['group_id']}', '{$A['perm_owner']}', '{$A['perm_group']}', '{$A['perm_members']}', '{$A['perm_anon']}'");
		      
		      // Update Totals and security      	
		    	plugin_moderationapprove_rating ($rid);
		    	
		    	$ret = -1;
		    } else {
					// Insert Review into Rating Submission table
					DB_save ($_TABLES['ratingsubmission'], 'rid,rt_id,created,score,nickname,location,title,pros,cons,bottomline,comment,owner_id,ipaddress',
	                    "'$rid','$rt_id',now(),$rating,'$nickname','$location','$title','$pros','$cons','$bottomline','$comment',$uid,'{$_SERVER['REMOTE_ADDR']}'");
	                    
	        if (isset ($_RATING_CONF['submission_notification']) && ($_RATING_CONF['submission_notification']==1)) {
                rating_sendNotification ((DB_getItem($_TABLES['rating_totals'],'title', "rt_id = '$rt_id'")),$title, $rating, $comment, $rt_id);
        	}
				}

    } else {
        COM_errorLog("save_review: $uid from {$_SERVER['REMOTE_ADDR']} tried "
                   . 'to submit a review with invalid $title and/or $comment.');
        return $ret = 5;
    }

    return $ret;
}

/**
* Send an email notification for a new review submission.
*
* @param    $title      string      comment title
* @param    $comment    string      text of the comment
* @param    $uid        integer     user id
* @param    $ipaddress  string      poster's IP address
* @param    $rid        integer     review id
*
*/
function review_sendNotification ($title, $rating, $comment, $uid, $ipaddress, $rid)
{
    global $_CONF, $_TABLES, $LANG03, $LANG08, $LANG09, $LANG_RATING;

    // we have to undo the addslashes() call from savecomment()
    $title = stripslashes ($title);
    $comment = stripslashes ($comment);

    // strip HTML if posted in HTML mode
    if (preg_match ('/<.*>/', $comment) != 0) {
        $comment = strip_tags ($comment);
    }

    $author = DB_getItem ($_TABLES['users'], 'username', "uid = '$uid'");
    if (($uid <= 1) && !empty ($ipaddress)) {
        // add IP address for anonymous posters
        $author .= ' (' . $ipaddress . ')';
    }

    $mailbody = "$LANG_RATING[51]: $title\n"
              . "$LANG03[5]: $author\n"
              . "$LANG_RATING[52]: $rating\n";

    if ($_CONF['emailstorieslength'] > 0) {
        if ($_CONF['emailstorieslength'] > 1) {
            $comment = substr ($comment, 0, $_CONF['emailstorieslength'])
                     . '...';
        }
        $mailbody .= $comment . "\n\n";
    }

    $mailbody .= $LANG08[33] . ' <' . $_CONF['site_url']
              . '/rating/review.php?mode=view&id=' . $rid . ">\n\n";

    $mailbody .= "\n------------------------------\n";
    $mailbody .= "\n$LANG08[34]\n";
    $mailbody .= "\n------------------------------\n";

    $mailsubject = $_CONF['site_name'] . ' ' . $LANG03[9];

    COM_mail ($_CONF['site_mail'], $mailsubject, $mailbody);
}


/**
* This function prints &$comments (db results set of comments) in comment format
* -For previews, &$comments is assumed to be an associative array containing
*  data for a single comment.
* 
* @param     array      &$comments Database result set of comments to be printed
* @param     string     $order     How to order the comments 'ASC' or 'DESC'
* @param     boolean    $delete_option   if current user can delete comments
* @param     boolean    $preview   Preview display (for edit) or not
* @return    string     HTML       Formated Comment 
*
*/
function get_review( &$comments, $order, $url, $delete_option = false, $preview = false )
{
    global $_CONF, $_TABLES, $_USER, $LANG01, $_IMAGE_TYPE, $LANG_RATING, $_RATING_CONF;

    $indent = 0;  // begin with 0 indent
    $retval = ''; // initialize return value

    //$template = new Template( $_CONF['path_layout'] . 'comment' );
    $template = new Template($_CONF['path'] . 'plugins/rating/templates');
    $template->set_file( array( 'comment' => 'review.thtml' ));

    // generic template variables
    $template->set_var( 'site_url', $_CONF['site_url'] );
    $template->set_var( 'layout_url', $_CONF['layout_url'] );
    $template->set_var( 'lang_replytothis', $LANG01[43] );
    $template->set_var( 'lang_reply', $LANG01[25] );
    $template->set_var( 'lang_authoredby', $LANG01[42] );
    $template->set_var( 'lang_on', $LANG01[36] );
    $template->set_var( 'order', $order );    

    // Make sure we have a default value for comment indentation
    if( !isset( $_CONF['comment_indent'] )) {
        $_CONF['comment_indent'] = 25;
    }

    if( $preview ) {
        $A = $comments;   
        if( empty( $A['nice_date'] )) {
            $A['nice_date'] = time();
        }
        //$mode = 'flat';
    } else {
        $A = DB_fetchArray($comments);
    }

		if ( empty($A['comment']) ) {
			$NotReview = true;
		} else {
			$NotReview = false;
		}

    if( empty( $A ) ) {
        return '';
    }

		if (rating_rt_is_digg($A['rt_id'])) { $is_digg = true;}

    $row = 1;
    do {


        // comment variables
        $template->set_var( 'indent', $indent );
        $template->set_var( 'author', $A['username'] );
        $template->set_var( 'author_id', $A['owner_id'] );
        $template->set_var( 'rt_id', $A['rt_id'] );
        $template->set_var( 'cssid', $row % 2 );

        if( $A['owner_id'] > 1 ) {
            if( empty( $A['fullname'] )) {
                $template->set_var( 'author_fullname', $A['username'] );
                $alttext = $A['username'];
            } else {
                $template->set_var( 'author_fullname', $A['fullname'] );
                $alttext = $A['fullname'];
            }

            $photo = '';
            if( $_CONF['allow_user_photo'] ) {
//                $photo = USER_getPhoto( $A['owner_id'], $A['photo'] );
            }
            if( !empty( $photo )) {
                $template->set_var( 'author_photo', $photo );
                $template->set_var( 'camera_icon', '<a href="'
                        . $_CONF['site_url']
                        . '/users.php?mode=profile&amp;uid=' . $A['owner_id']
                        . '"><img src="' . $_CONF['layout_url']
                        . '/images/smallcamera.' . $_IMAGE_TYPE
                        . '" border="0" alt=""></a>' );
            } else {
                $template->set_var( 'author_photo', '' );
                $template->set_var( 'camera_icon', '' );
            }

            $template->set_var( 'start_author_anchortag', '<a href="'
                    . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid='
                    . $A['owner_id'] . '">' );
            $template->set_var( 'end_author_anchortag', '</a>' );
        } else {
            $template->set_var( 'author_fullname', $A['username'] );
            $template->set_var( 'author_photo', '' );
            $template->set_var( 'camera_icon', '' );
            $template->set_var( 'start_author_anchortag', '' );
            $template->set_var( 'end_author_anchortag', '' );
        }

        // this will hide HTML that should not be viewed in preview mode
        if( $preview || $hidefromanon ) {
            $template->set_var( 'hide_if_preview', 'style="display:none"' );
        } else {
            $template->set_var( 'hide_if_preview', '' );
        }

        $template->set_var( 'date', strftime( $_CONF['date'], $A['nice_date'] ));

        // If deletion is allowed, displays delete link (this varible is for the owner of the rating)
        // Now check if you show individual rating or review
		    // never trust $uid ...
		    if (empty ($_USER['uid'])) {
		        $uid = 1;
		    } else {
		        $uid = $_USER['uid'];
		    }        

        // this will hide HTML that should not be viewed when user logged in
        if( $uid > 1 ) {
            $template->set_var( 'hide_if_user', 'style="display:none"' );
        } else {
            $template->set_var( 'hide_if_user', '' );
        }


        // *****************************************************
        // Edit & delete links
        $UserFlag = false;
        if ($uid > 1) {
			    $sql = 'SELECT COUNT(*) AS count, owner_id, group_id, perm_owner, perm_group, '
			         . "perm_members, perm_anon FROM {$_TABLES['rating']} WHERE (rid = '" . $A['rid'] . "') "
			         . 'AND (created <= NOW())' . COM_getPermSQL('AND') 
			         . 'GROUP BY rid';
			    $result = DB_query ($sql);
			    $B = DB_fetchArray ($result);
			    $allowed = $B['count'];
			
			    if ( $allowed >= 1 ) {
			        $access = SEC_hasAccess( $B['owner_id'], $B['group_id'],
			                $B['perm_owner'], $B['perm_group'], $B['perm_members'],
			                $B['perm_anon'] );    
			        if ($access == 3) {$UserFlag = true;}
	        }
				}        
        
        
        if( $delete_option || ($UserFlag)) {
        		$deloption = '[ ';
        		If ($delete_option) {
							$onclick = 'onclick="return confirm(' . "'" . $LANG_RATING['delete_confirm'] . "'" . ');"'; // Delete Confirm
							
	            $deloption .= '<a href="' . $_CONF['site_admin_url']
	                       . '/plugins/rating/index.php?mode=edit&amp;rid=' . $A['rid'] . '&amp;rt_id=' . $A['rt_id'] 
	                       . '">' . $LANG01[04] . '</a>'
	            					 . ' | <a href="' . $_CONF['site_url']
	                       . '/rating/review.php?mode=delete&amp;rid='
	                       . $A['rid'] . '&amp;rt_id=' . $A['rt_id'] . '" ' . $onclick . '>' . $LANG01[28] . '</a> ';

	            if( !empty( $A['ipaddress'] )) {
	                if( empty( $_CONF['ip_lookup'] )) {
	                    $deloption .= '| ' . $A['ipaddress'] . ' ';
	                } else {
	                    $iplookup = str_replace( '*', $A['ipaddress'],
	                                             $_CONF['ip_lookup'] );
	                    $deloption .= '| <a href="' . $iplookup . '">'
	                               . $A['ipaddress'] . '</a> ';
	                }
	            }
             } elseif (!$delete_option && $UserFlag) {          

            	$deloption .= '<a href="' . $_CONF['site_url']                       
                       . '/rating/review.php?mode=edit&amp;rid=' . $A['rid'] . '&amp;rt_id=' . $A['rt_id'] 
                       . '">' . $LANG01[04] . '</a>';
             }          
				// ***************************************************** 
                      

            $deloption .= ' ]';
            $template->set_var( 'delete_option', $deloption );
        } else {
            $template->set_var( 'delete_option', '' );
        }

        // and finally: format the actual text of the comment
        if( preg_match( '/<.*>/', $A['comment'] ) == 0 ) {
            $A['comment'] = nl2br( $A['comment'] );
        }

        // highlight search terms if specified
        if( !empty( $_REQUEST['query'] )) {
            $A['comment'] = COM_highlightQuery( $A['comment'],
                                                $_REQUEST['query'] );
        }

				$review_for = DB_getItem($_TABLES['rating_totals'], 'title_link', "rt_id='" . $A['rt_id'] . "'");
				if( $review_for == '' ) {
					$review_for = DB_getItem($_TABLES['rating_totals'], 'title', "rt_id='" . $A['rt_id'] . "'");
				}
        if( $review_for == '' ) {
        	$template->set_var( 'hide_no_review_for', 'style="display:none"' );
					$template->set_var( 'lang_review_for', '');
	        $template->set_var( 'review_for', '' );

        } else {
					$template->set_var( 'lang_review_for', $LANG_RATING[340]);
	        $template->set_var( 'review_for', $review_for );
	      }

      	$template->set_var( 'lang_location', $LANG_RATING[339]);
        if( $A['location'] == '' ) {
          $template->set_var( 'hide_no_location', 'style="display:none"' );
          $template->set_var( 'location', '' );
        } else {
        	$template->set_var( 'hide_no_location', '' );
	        $template->set_var( 'location', $A['location'] );
	      }
        if( $A['nickname'] == '' ) {
          $template->set_var( 'nickname', '' );
        } else {
	        $template->set_var( 'nickname', ' (' . $A['nickname'] . ')' );
	      }


        $A['comment'] = str_replace( '$', '&#36;',  $A['comment'] );
        $A['comment'] = str_replace( '{', '&#123;', $A['comment'] );
        $A['comment'] = str_replace( '}', '&#125;', $A['comment'] );

        // Replace any plugin autolink tags
        $A['comment'] = PLG_replaceTags( $A['comment'] );
        
        
        // format title for display, must happen after reply_link is created
        $A['title'] = htmlspecialchars( $A['title'] );
        $A['title'] = str_replace( '$', '&#36;', $A['title'] );
        $A['title'] = COM_stripslashes ($A['title']);
        $A['pros'] = htmlspecialchars( $A['pros'] );
        $A['pros'] = str_replace( '$', '&#36;', $A['pros'] );
        $A['pros'] = COM_stripslashes ($A['pros']);
        $A['cons'] = htmlspecialchars( $A['cons'] );
        $A['cons'] = str_replace( '$', '&#36;', $A['cons'] );
        $A['cons'] = COM_stripslashes ($A['cons']);
        $A['bottomline'] = htmlspecialchars( $A['bottomline'] );
        $A['bottomline'] = str_replace( '$', '&#36;', $A['bottomline'] );
				$A['bottomline'] = COM_stripslashes ($A['bottomline']);

        $template->set_var( 'title', $A['title'] );
        if( $A['pros'] == '' ) {
            $template->set_var( 'hide_no_pros', 'style="display:none"' );
            $template->set_var( 'pros', '' );
        } else {
        	$template->set_var( 'hide_no_pros', '' );
	        $template->set_var( 'pros', $A['pros'] );
	      }
        if( $A['cons'] == '' ) {
            $template->set_var( 'hide_no_cons', 'style="display:none"' );
            $template->set_var( 'cons', '' );
        } else {
        	$template->set_var( 'hide_no_cons', '' );
	        $template->set_var( 'cons', $A['cons'] );
	      }
        if( $A['bottomline'] == '' ) {
            $template->set_var( 'hide_no_bottomline', 'style="display:none"' );
            $template->set_var( 'bottomline', '' );
        } else {
        	$template->set_var( 'hide_no_bottomline', '' );
		      $template->set_var( 'bottomline', $A['bottomline'] );
        }
        $template->set_var( 'lang_pros', $LANG_RATING[335] );
        $template->set_var( 'lang_cons', $LANG_RATING[336] );
        $template->set_var( 'lang_bottomline', $LANG_RATING[337] );


        $template->set_var( 'comments', $A['comment'] );
        
        
				$template->set_var( 'lang_rating', $LANG_RATING[111]);
    		if ($is_digg) {
    			$template->set_var( 'lang_rating', $LANG_RATING[119]);
    			$template->set_var( 'rating','');
    			
    			$template->set_var( 'hide_question', 'style="display:none"' );
    			$template->set_var( 'review_question', '' );
    			$template->set_var( 'buttons_yes_no', '' );
    		} else { 	
    			$template->set_var( 'lang_rating', $LANG_RATING[111]);
					$template->set_var( 'rating', RATING_rating_as_html($A['score'], DB_getItem($_TABLES['rating_totals'], 'score_max', "rt_id='" . $A['rt_id'] . "'"),$_RATING_CONF['user_review_default_display']));
					
					// Helpful Question	
					if($preview || $NotReview) {
	    			$template->set_var( 'hide_question', 'style="display:none"' );
	    			$template->set_var( 'review_question', '' );
	    			$template->set_var( 'buttons_yes_no', '' );
					} else {
						$template->set_var( 'hide_question', '' );
		        $review_question = $A['helpful_yes'] . $LANG_RATING[345] . ($A['helpful_yes']+$A['helpful_no']) . $LANG_RATING[346];
		        $template->set_var( 'review_question', $review_question );
						$template->set_var( 'rid', $A['rid'] );
						$template->set_var( 'rt_id', $A['rt_id'] );
						$template->set_var( 'url', $url );
						
						if ($_RATING_CONF['use_image_buttons'] == 1) {
							$button_info = '&nbsp;<input type="image" value="' . $LANG_RATING[347] . '" name="mode" border="0" src="' . $_CONF["site_url"] . '/rating/images/yesbutton.gif">';
							$button_info .= '&nbsp;<input type="image" value="' . $LANG_RATING[348] . '" name="mode" border="0" src="' . $_CONF["site_url"] . '/rating/images/nobutton.gif">';
						} else {
							$button_info = '&nbsp;<input type="submit" value="' . $LANG_RATING[347] . '" name="mode">';
							$button_info .= '&nbsp;<input type="submit" value="' . $LANG_RATING[348] . '" name="mode">';
						}
						$template->set_var( 'buttons_yes_no', $button_info );
					}
				}
        // parse the templates
      	//$template->set_var( 'pid', $A['cid'] );
	      $retval .= $template->parse( 'output', 'comment' );   

        $row++;
    } while( $A = DB_fetchArray( $comments ));

    return $retval;
}


/**
 * Handles a comment view request
 *
 * @copyright Vincent Furia 2005
 * @author Vincent Furia <vinny01 AT users DOT sourceforge DOT net>
 * @param boolean $view View or display (true for view)
 * @return string HTML (possibly a refresh)
 */
function handleView($url)
{
    global $_CONF, $_TABLES, $_USER, $LANG_ACCESS, $LANG_RATING;

    $rt_id = COM_applyFilter ($_REQUEST['rt_id'], false);

    if ($rt_id == '') {
        return COM_refresh($_CONF['site_url'] . '/index.php');
    }

    $sql = 'SELECT COUNT(*) AS count, owner_id, group_id, perm_owner, perm_group, '
         . "perm_members, perm_anon FROM {$_TABLES['rating']} WHERE (rt_id = '$rt_id') "
         . 'AND (created <= NOW())' . COM_getPermSQL('AND') 
         . 'GROUP BY rt_id';
    $result = DB_query ($sql);
    $B = DB_fetchArray ($result);
    $allowed = $B['count'];

    if ( $allowed >= 1 ) {
        $delete_option = ( SEC_hasRights( 'rating.edit' ) &&
            ( SEC_hasAccess( $B['owner_id'], $B['group_id'],
                $B['perm_owner'], $B['perm_group'], $B['perm_members'],
                $B['perm_anon'] ) == 3 ) );
        $display .= user_reviews ($rt_id, $title, 
                COM_applyFilter ($_REQUEST['order']),
                COM_applyFilter ($_REQUEST['page'], true), $delete_option, $url);
    } else {
        $display .= COM_startBlock ($LANG_ACCESS['accessdenied'], '',
                            COM_getBlockTemplate ('_msg_block', 'header'))
                 . $LANG_RATING['noaccessrating']
                 . COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    }


    return COM_siteHeader() . $display . COM_siteFooter();
}

// MAIN

$display = '';

$host = $_SERVER['HTTP_HOST'];
$url = $_SERVER['HTTP_REFERER'];
if (isset($_REQUEST['url']))
{
	$url = $_REQUEST['url'];
} else {
	if (!strstr($url, $host))
	{
	    $url = $_CONF['site_url'];
	}
}

switch ( $_REQUEST['mode'] ) {
case $LANG03[14]: // Preview
    $display .= COM_siteHeader()
        . review_form ($_POST['nickname'], $_POST['location'], strip_tags ($_POST['title']), $_POST['pros'], $_POST['cons'], $_POST['bottomline'], $_POST['score'], $_POST['comment'],
            COM_applyFilter ($_POST['rt_id']), COM_applyFilter ($_POST['mode']),
            COM_applyFilter ($_POST['postmode']), $url)
        . COM_siteFooter(); 
    break;

case $LANG_RATING[54]: 
    $display .= handleSubmit();  // moved to function for readibility
    break;

case 'delete':
    $display .= handleDelete($url);  // moved to function for readibility
    break;

case $LANG_RATING[347]: // Review Helpful Yes
		$display = updatehelpful (true, $url);
		
		break;
		
case $LANG_RATING[348]: // Review Helpful No 
		$display = updatehelpful (false, $url);

		break;
		
case 'edit':
    $rt_id = COM_applyFilter ($_REQUEST['rt_id']);
    $rid = COM_applyFilter ($_REQUEST['rid']);

    if (!empty ($rt_id) && !empty ($rid)) { 

	    if (DB_count ($_TABLES['rating'], 'rid', $rid) > 0) {
	        $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['rating']} WHERE rid = '{$rid}'");
	        $A = DB_fetchArray ($result);
	        $access = SEC_hasAccess ($A['owner_id'], $A['group_id'],
	                $A['perm_owner'], $A['perm_group'], $A['perm_members'],
	                $A['perm_anon']);
	        $group_id = $A['group_id'];
	    } else {
	        $access = SEC_hasAccess ($owner_id, $group_id, $perm_owner, $perm_group,
	                $perm_members, $perm_anon);
	    }
	    
	    if (($access == 3) && SEC_inGroup ($group_id)) {
	    	
	    		// Get required info
	        $result = DB_query( "SELECT * FROM {$_TABLES['rating']} WHERE rid = '$rid'" );
	        $N = DB_fetchArray( $result );
	        
	        
	        $display .= COM_siteHeader('menu', $LANG03[1])
	            . review_form ($N['nickname'], $N['location'], $N['title'], $N['pros'], $N['cons'], $N['bottomline'], $N['score'], $N['comment'], $rt_id, COM_applyFilter ($_REQUEST['mode']), COM_applyFilter ($_REQUEST['postmode']), $url)
	            . COM_siteFooter();
	    } else {  //      if ($access == 0 OR $access == 2) {
	      $display .= COM_startBlock($LANG_RATING[310], '',
	                         COM_getBlockTemplate ('_msg_block', 'header'));
	      $display .= $LANG_RATING[311];
	      $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
	      COM_accessLog("User {$_USER['username']} tried to illegally submit or edit a rating/review $rid.");
			}
    } else {
        $display .= COM_refresh($_CONF['site_url'] . '/index.php');
    }
    break;

case 'view':
		// Update views of rating, doing it here instead of in function so not to many views for one user
		$result = DB_query( "Update {$_TABLES['rating_totals']} Set hits = hits + 1 WHERE rt_id = '$rt_id'" );
		
    $display .= handleView($url);  // moved to function for readibility
    break;

default:  // New Comment
    $rt_id = COM_applyFilter ($_REQUEST['rt_id']);

    if (!empty ($rt_id)) { 
    
        
        
        $display .= COM_siteHeader('menu', $LANG03[1])
            . review_form ('', '', $title, '', '', '', '', '', $rt_id, COM_applyFilter ($_REQUEST['mode']), COM_applyFilter ($_REQUEST['postmode']), $url)
            . COM_siteFooter();
    } else {
        $display .= COM_refresh($_CONF['site_url'] . '/index.php');
    }
    break;
}


echo $display;

?>
