<?php

// Reminder: always indent with 4 spaces (no tabs). 
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Rating plugin 2.0 for Geeklog                                             |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | functions.inc                                                             |
// |                                                                           |
// | config file for the Rating plugin for Geeklog.                         |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Copyright  (C) 2006 Euan McKay  - info AT heatherengineering DOT com      |
// | Copyright  (C) 2006 Tom Homer	 - TomHomer AT cogeco DOT com              |
// | For support and information, visit http://www.heatherengineering.com/     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Based on the Universal Plugin and prior work by the following authors:    |
// |                                                                           |
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs        - tony AT tonybibbs DOT com                    |
// |          Tom Willett       - tom AT pigstye DOT net                       |
// |          Blaine Lang       - blaine AT portalparts DOT com                |
// |          Dirk Haun         - dirk AT haun-online DOT de                   |
// |          Vincent Furia     - vinny01 AT users DOT sourceforge DOT net     |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// ***************************************************
// Geeklog changes

// Add in moderate security
$_SQL[] = "INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) VALUES ('rating.moderate', 'Ability to moderate a rating & review submission')";
$_SQL[] = "INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES 
((SELECT ft_id FROM {$_TABLES['features']} WHERE ft_name = 'rating.moderate'), 
(SELECT grp_id FROM {$_TABLES['groups']} WHERE grp_name = 'Rating Admin'))";

$_SQL[] = "DELETE FROM {$_TABLES['groups']} WHERE grp_name = 'Rating User'";


// ***************************************************
// Rating Submission table

$_SQL[] = "
CREATE TABLE IF NOT EXISTS {$_TABLES['ratingsubmission']} (  
`rid` varchar(40) NOT NULL default '',          
`rt_id` varchar(40) NOT NULL default '',        
`created` datetime default NULL,                
`score` int(2) NOT NULL default '0',           
`title` varchar(128) NULL,
`comment` text NULL,                             
`owner_id` mediumint(8) unsigned NOT NULL default '1',  
`ipaddress` varchar(15) NULL,                    
INDEX rating_uid(`owner_id`),                         
INDEX rating_date(`created`),                    
PRIMARY KEY (`rid`)
) TYPE=MyISAM
";


// ***************************************************
// Rating table changes

$_SQL[] = "
CREATE TABLE {$_TABLES['rating']} (      
`rid` varchar(40) NOT NULL default '',          
`rt_id` varchar(40) NOT NULL default '',        
`created` datetime default NULL,                
`score` int(2) NOT NULL default '0',            
`title` varchar(128) NULL,
`comment` text NULL,                            
`ipaddress` varchar(15) NULL,                    
`owner_id` mediumint(8) unsigned NOT NULL default '1', 
`group_id` mediumint(8) unsigned NOT NULL default '1',
`perm_owner` tinyint(1) unsigned NOT NULL default '3',
`perm_group` tinyint(1) unsigned NOT NULL default '2',
`perm_members` tinyint(1) unsigned NOT NULL default '2',
`perm_anon` tinyint(1) unsigned NOT NULL default '2',
INDEX rating_uid(`owner_id`),                         
INDEX rating_date(`created`),                   
PRIMARY KEY (`rid`)
) TYPE=MyISAM
";

// Copy info from old table to new table
$_SQL[] = "INSERT INTO {$_TABLES['rating']} ( `rid`, `rt_id`, `created`, `score`, `ipaddress`, `owner_id`)
SELECT `rid`, `rt_id`, `created`, `score`, `ipaddress`, `uid` FROM `gl_rating_items`";


// Delete old table
$_SQL[] = "DROP TABLE gl_rating_items";

// ***************************************************
// Rating Totals table changes

$_SQL[] = "
CREATE TABLE gl_rating_totals_temp (
`rt_id` varchar(40) NOT NULL default '',         
`item_type` varchar(255) default NULL,          
`item_id` varchar(40) NOT NULL default '',      
`group` varchar(40) default NULL,           
`score_min` int(2) NOT NULL default '0',        
`score_max` int(2) NOT NULL default '0',        
`count` int(11) NOT NULL default '0',        
`total` int(11) NOT NULL default '0',
`title` varchar(128) NULL,
`comment` text NULL,      
`created` datetime default NULL,                      
`owner_id` mediumint(8) unsigned NOT NULL default '1',  
`group_id` mediumint(8) unsigned NOT NULL default '1',
`perm_owner` tinyint(1) unsigned NOT NULL default '3',
`perm_group` tinyint(1) unsigned NOT NULL default '2',
`perm_members` tinyint(1) unsigned NOT NULL default '2',
`perm_anon` tinyint(1) unsigned NOT NULL default '2',
INDEX rating_type(`item_type`),                 
PRIMARY KEY (`rt_id`)
) TYPE=MyISAM
";

// Copy info from old table to new table
$_SQL[] = "INSERT INTO gl_rating_totals_temp ( `rt_id`, `item_type`, `score_min`, `score_max`, `count`, `total`, `created`)
SELECT `rt_id`, LOWER(`item_type`), `score_min`, `score_max`, `count`, `total`, NOW() FROM `gl_rating_totals`";

// Delete old rating totals table
$_SQL[] = "DROP TABLE gl_rating_totals";

// rename temp table to gl_ratings_totals
$_SQL[] = "RENAME TABLE gl_rating_totals_temp TO {$_TABLES['rating_totals']}";



// ***************************************************
// Used to update group ids for old rating records

function RATING_fix_group_id()
{
	global $_CONF, $_TABLES;

	//get rating group id
	$sql = "SELECT grp_id FROM {$_TABLES['groups']} WHERE grp_name = 'Rating Admin'";
	$R = DB_query( $sql );
  $A = DB_fetchArray($R);
  $group_id = $A['grp_id'];	

	$sql = "UPDATE {$_TABLES['rating']}
				SET group_id = " . $group_id;
	$R = DB_query( $sql );

	$sql = "UPDATE {$_TABLES['rating_totals']}
				SET group_id = " . $group_id;
	$R = DB_query( $sql );

}

?>
